#define _CRT_SECURE_NO_WARNINGS
#define ll long long
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

vector<int> parent, with_up, without_up, color, fathers;
vector<bool> well_up;
vector<vector<int>> children, downs;
int t = 0;
const int U = 000000, V = 150000;

int G = 0;

void dfs(const int& v)
{
	++G;
	if (G > V)
	return;
	color[v] = t;
	well_up[v] = true;
	without_up[v] = 0;
	with_up[v] = 0;
	for (int i = 0; i < ((int)(children[v].size())); ++i)
	{
		dfs(children[v][i]);
		with_up[v] += without_up[children[v][i]];
		well_up[v] = well_up[v] && (well_up[children[v][i]] == false);
	}
	if (well_up[v])
		without_up[v] = with_up[v] + 1;
	else
		without_up[v] = with_up[v] - 1;

	--G;
	if (G > V)
	return;
}

void dfs1(const int& v, const bool& will_up)
{

	++G;
	if (G > V)
	return;
	int u = -1;
	if (!will_up)
	{
		for (int i = 0; (u == -1) && (i < ((int)(children[v].size()))); ++i)
		if (well_up[children[v][i]])
			u = i;
		if (u == -1)
			downs[t].push_back(v);
	}
	for (int i = 0; i < ((int)(children[v].size())); ++i)
		dfs1(children[v][i], u == i);

	--G;
	if (G > V)
	return;
}


void dfs2(const int& v)
{

	++G;
	if (G > V)
	return;
	color[v] = t;
	well_up[v] = true;
	without_up[v] = 0;
	with_up[v] = 0;
	for (int i = 0; i < ((int)(children[v].size())); ++i)
	{
		dfs2(children[v][i]);
		with_up[v] += without_up[children[v][i]];
		well_up[v] = well_up[v] && (well_up[children[v][i]] == false);
	}
	if (well_up[v])
		without_up[v] = with_up[v] + 1;
	else
		without_up[v] = with_up[v] - 1;

	--G;
	if (G > V)
	return;
}

struct col
{
	int n;
	bool operator<(const col& y)
	{
		if (well_up[fathers[n]] != well_up[fathers[y.n]])
			return well_up[fathers[n]];
		if ((well_up[fathers[n]]) && (downs[n].size() != downs[y.n].size()))
			return ((int)(downs[n].size())) < ((int)(downs[y.n].size()));
		return n > y.n;
	}
};

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	freopen("hidden.in", "r", stdin);
	freopen("hidden.out", "w", stdout);
	int n;
	cin >> n;
	parent.resize(n + U);
	children.resize(n + U);
	with_up.resize(n + U);
	well_up.resize(n + U);
	color.resize(n + U);
	without_up.resize(n + U);
	parent[0] = -1;
	for (int i = 1; i < n; ++i)
	{
		cin >> parent[i];
		if ((--parent[i]) >= 0)
			children[parent[i]].push_back(i);
	}
	for (int i = 0; i < n; ++i)
	{
		if (parent[i] == -1)
		{
			dfs(i);
			if (i == 0)
				well_up[i] = false;
			downs.push_back(vector<int>(0));
			dfs1(i, well_up[i]);
			fathers.push_back(i);
			++t;
		}
	}
	vector<col> c(t);
	for (int i = 0; i < t; ++i)
		c[i].n = i;
	sort(c.begin(), c.end());
	vector<int> colors(t);
	for (int i = 0; i < t; ++i)
		colors[i] = c[i].n;
	int m = 0, q = 0;
	bool cru = false;
	for (; (m < t) && (well_up[fathers[colors[m]]]); ++m);
	int i;
	for (i = 0; ((q < t) && (i < m)); ++i)
	{
		while (q <= i)
			++q;
		while ((q < t) && (downs[colors[q]].size() == 0))
			++q;
		if (q < t)
		{
			parent[fathers[colors[i]]] = downs[colors[q]].back();
			downs[colors[q]].pop_back();
		}
		else
			cru = true;
	}
	if (cru)
	{
		--i;
		for (int j = i; j < t - 1; ++j)
			parent[fathers[colors[j]]] = fathers[colors[j + 1]];
	}
	else
	{
		for (int j = i; j < t - 1; ++j)
			parent[fathers[colors[j]]] = fathers[colors[j + 1]];
	}

	for (int i = 0; i < n; ++i)
	{	
		children[i].clear();
	}
	for (int i = 1; i < n; ++i)
	{
		//if (parent[i] >= 0)
			children[parent[i]].push_back(i);
	}
	dfs2(0);




	cout << (n - without_up[0]) / 2 << '\n';
	for (int i = 1; i < n; ++i)
		cout << parent[i] + 1 << ' ';
	return 0;
}
