#include <bits/stdc++.h>

using namespace std;

template <typename T>
T input() {
    T res;
    cin >> res;
    return res;
}

#define ALL(V) V.begin(), V.end()
#define SZ(V) int((V).size())
#define TYPEMAX(T) std::numeric_limits<T>::max()
#define TYPEMIN(T) std::numeric_limits<T>::min()

bool dfs(const vector<vector<int>>& graph, vector<char>& used, int v, vector<int>& lst) {
    lst.push_back(v);
    used[v] = 1;

    for (int u: graph[v]) {
        if (used[u] == 0) {
            if (dfs(graph, used, u, lst)) {
                return true;
            }
        } else if (used[u] == 1) {
            lst.push_back(u);
            return true;
        }
    }

    lst.pop_back();
    used[v] = 2;
    return false;
}

string solve(vector<vector<int>>& graph) {
    int n = graph.size();
    vector<char> used(n);
    for (int i = 0; i != n; ++i)
        if (not used[i]) {
            vector<int> lst;
            if (dfs(graph, used, i, lst)) {
                lst.erase(lst.begin(), 1 + std::find(lst.begin(), lst.end(), lst.back()));

                vector<int> remap(n);
                int gid = 0;
                for (int i = 0; i != n; ++i)
                    if (std::find(ALL(lst), i) == lst.end())
                        remap[i] = gid++;
                    else
                        remap[i] = -1;

                for (int i = 0; i != n; ++i)
                    if (remap[i] == -1)
                        remap[i] = gid;
                gid += 1;

                vector<vector<int>> newgraph(n);
                for (int i = 0; i != n; ++i)
                    for (int j: graph[i])
                        if (remap[i] != remap[j])
                            newgraph[remap[i]].push_back(remap[j]);
                return solve(newgraph);
            }
        }

    vector<int> masks(n);
    for (int i = 0; i != n; ++i)
        for (int j: graph[i])
            masks[i] |= (1 << j);

            #ifdef LOCAL
    for (int i = 0; i != n; ++i, cout << "!\n")
        for (int j: graph[i])
            cout << j << " ";
#endif

    string res;
    res += std::to_string(graph.size());
    res += " ";
    int64_t top = 1;
    int64_t div = 1;

    for (int i = 1; i <= n; ++i)
        div *= i;

    vector<int64_t> dp(1 << n);
    dp[0] = 1;
    for (int mask = 1; mask != (1 << n); ++mask) {
        for (int v = 0; v != n; ++v)
        if (mask & (1 << v))
            if ((mask & masks[v]) == 0)
                dp[mask] += dp[mask ^ (1 << v)];
    }

    top = dp.back();

    auto g = std::__gcd(top, div);
    top /= g;
    div /= g;
    res += std::to_string(top);
    res += '/';
    res += std::to_string(div);
    return res;
}
int main() {
    std::iostream::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    #ifndef LOCAL
    freopen("fygon20.in", "r", stdin);
    freopen("fygon20.out", "w", stdout);
    #else
    freopen("grand.txt", "r", stdin);
    #endif // LOCAL

    int n;
    cin >> n;

    n -= 1;

    std::map<char, int> mp;
    mp['n'] = -1;

    vector<vector<int>> graph(n);

    for (int i = 0; i != n; ++i) {
        input<string>();
        string name = input<string>();
        input<string>();
        string range = input<string>();
        range += input<string>();

        int pos = std::find(range.begin(), range.end(), '(') - range.begin() + 1;

        int A = (range[pos] == '1' ? -1 : mp[range[pos]]);
         pos = std::find(range.begin(), range.end(), ')') - range.begin() - 1;

        int B = (range[pos] == 'n' ? -1 : mp[range[pos]]);

        if (A != -1)
            graph[A].push_back(i);
        if (B != -1)
            graph[i].push_back(B);
        mp[name[0]] = i;
    }

    cout << solve(graph) << "\n";

    return 0;
}
