#include <bits/stdc++.h>

using namespace std;

template <typename T>
T input() {
    T res;
    cin >> res;
    return res;
}

#define ALL(V) V.begin(), V.end()
#define SZ(V) int((V).size())
#define TYPEMAX(T) std::numeric_limits<T>::max()
#define TYPEMIN(T) std::numeric_limits<T>::min()

pair<pair<int, int>, pair<int, int>> ans;

bool dfs(const vector<vector<int>>& graph, vector<char>& used, vector<int>& p, int v, int thep, vector<pair<int, int>>& mrk) {
    p[v] = thep;
    used[v] = 1;

    for (int u: graph[v])
    if (u != thep) {
        if (used[u] == 0) {
            if (dfs(graph, used, p, u, v, mrk))
                return true;
        } else if (used[u] == 1) {
            for (int go = v; go != u; go = p[go]) {
                if (mrk[go].first == -1) {
                    mrk[go] = {v, u};
                } else {
                    ans = {mrk[go], {v, u}};
                    return true;
                }
            }
        }
    }
    used[v] = 2;
    return false;
}

int main() {
    std::iostream::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    #ifndef LOCAL
    freopen("grand.in", "r", stdin);
    freopen("grand.out", "w", stdout);
    #else
    freopen("grand.txt", "r", stdin);
    #endif // LOCAL

    for (int T = input<int>(); T != 0; --T) {
        int n = input<int>();
        int m = input<int>();

        vector<vector<int>> graph(n);
        for (int i = 0; i != m; ++i) {
            int v = input<int>() - 1;
            int u = input<int>() - 1;

            graph[v].push_back(u);
            graph[u].push_back(v);
        }

        vector<pair<int, int>> mrk(n, {-1, -1});
        vector<char> used(n, false);
        vector<int> p(n, -1);
        bool scs = false;
        for (int i = 0; i != n and not scs; ++i)
            if (not used[i])
                scs = dfs(graph, used, p, i, -1, mrk);
        if (not scs) {
            cout << "-1\n";
        } else {
            #define pb push_back
            vector<int> p1, p2;

            for (int v = ans.first.first; v != ans.first.second; v = p[v])
                p1.pb(v);
            p1.pb(ans.first.second);

            for (int v = ans.second.first; v != ans.second.second; v = p[v])
                p2.pb(v);
            p2.pb(ans.second.second);

            /*
            for (auto elem: p1)
                cout << elem << " " ;
            cout << "!\n";
            for (auto elem: p2)
                cout << elem << " " ;
            cout << "!\n";*/

            set<int> s1;
            for (auto elem: p1)
                s1.insert(elem);

            vector<int> cmn;
            for (int i = 0; i != SZ(p2); ++i)
                if (s1.count(p2[i]))
                    cmn.push_back(p2[i]);

            cout << cmn[0] + 1 << " " << cmn.back() + 1 << "\n";

            cout << cmn.size();
            for (auto elem: cmn)
                cout << " " << elem + 1;
            cout << "\n";

            auto patch = [&](vector<int>& gg) {
                int p1 = std::find(gg.begin(), gg.end(), cmn[0]) - gg.begin();
                int p2 = std::find(gg.begin(), gg.end(), cmn.back()) - gg.begin();

                gg.erase(gg.begin() + p1 + 1, gg.begin() + p2);
                std::rotate(gg.begin(), gg.begin() + p1 + 1, gg.end());
                std::reverse(ALL(gg));
            };

            patch(p1);
            patch(p2);

            cout << p1.size();
            for (auto elem: p1)
                cout << " " << elem + 1;
            cout << "\n";

            cout << p2.size();
            for (auto elem: p2)
                cout << " " << elem + 1;
            cout << "\n";

        }
    }

    return 0;
}
