#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <iomanip>
#include <ctime>
#include <algorithm>

using namespace std;

#define ull unsigned long long
#define llong long long

#define ldouble long double

#define FILE_NAME "intel"

#define INP_FNAME FILE_NAME##".in"
#define OUT_FNAME FILE_NAME##".out"

struct point
{
	llong x;
	llong y;

	point() {}
	point(llong _x, llong _y) : x(_x), y(_y) {}
};

struct edge
{
	point vtx1;
	point vtx2;
};

edge e[1010];

const llong pinf = 2100000000;
const llong ninf = -2100000000;

int main()
{
#ifdef LOCAL_JUDGE
	freopen( "input.txt", "rb", stdin );
	freopen( "output.txt", "wb", stdout );

	clock_t timeStart = 0, timeStop = 0;

	timeStart = clock();
#else
	freopen( INP_FNAME, "rb", stdin );
	freopen( OUT_FNAME, "wb", stdout );
#endif /* LOCAL_JUDGE */

	llong n = 0;
	
	llong i = 0, j = 0;

	llong x = 0, y = 0;

	llong ans = 0;

	cin >> n;

	cin >> x >> y;
	e[n - 1].vtx2 = point(x, y);

	for (i = 0; i < n - 1; i++)
	{
		e[i].vtx1 = point(x, y);
		cin >> x >> y;
		e[i].vtx2 = point(x, y);
	}

	e[n - 1].vtx1 = point(x, y);

	for (i = 0; i < n; i++)
	{
		if (e[i].vtx1.x == e[i].vtx2.x) // handling vertical edges
		{
			llong lcoverup = max(e[i].vtx1.y, e[i].vtx2.y), lcoverdown = min(e[i].vtx1.y, e[i].vtx2.y);
			llong rcoverup = lcoverup, rcoverdown = lcoverdown;

			for (j = 0; j < n; j++)
			{
				if ((e[j].vtx1.y == e[j].vtx2.y) || (i == j)) // skip horisontal edges and the same edge
				{
					continue;
				}

				llong upy = 0;
				llong downy = 0;

				if (e[j].vtx1.y > e[j].vtx2.y)
				{
					upy = e[j].vtx1.y;
					downy = e[j].vtx2.y;
				}
				else
				{
					downy = e[j].vtx1.y;
					upy = e[j].vtx2.y;
				}

				if (e[j].vtx1.x < e[i].vtx1.x) // if the edge is on the left side
				{
					if (upy >= lcoverup)
					{
						lcoverup = min(lcoverup, downy);
					}
					else
					{
						lcoverdown = max(lcoverdown, upy);
					}
				}
				else // ... on the right side (we don't care if it's right above or right below us, since in this case we just don't update "covers" anyway)
				{
					if (upy >= rcoverup)
					{
						rcoverup = min(rcoverup, downy);
					}
					else
					{
						rcoverdown = max(rcoverdown, upy);
					}
				}
			}

			// unite "covers" and find the total covering

			int all = 0;

			if (rcoverup < rcoverdown) // top is covered
			{
				rcoverup = ninf;
				rcoverdown = pinf;
				all++;
			}

			if (lcoverup < lcoverdown)
			{
				lcoverdown = pinf;
				lcoverup = ninf;
				all++;
			}

			llong uncovered = max(rcoverup, lcoverup) - min(rcoverdown, lcoverdown);

			if (all == 2)
			{
				uncovered = 0;
			}

			if (uncovered <= 0)
			{
				ans += abs(e[i].vtx1.y - e[i].vtx2.y);
			}
			else
			{
				ans += (abs(e[i].vtx1.y - e[i].vtx2.y) - uncovered);
			}
		}
		else // handling horizontal edges
		{
			llong ucoverleft = min(e[i].vtx1.x, e[i].vtx2.x), ucoverright = max(e[i].vtx1.x, e[i].vtx2.x);
			llong dcoverleft = ucoverleft, dcoverright = ucoverright;

			for (j = 0; j < n; j++)
			{
				if ((e[j].vtx1.x == e[j].vtx2.x) || (i == j)) // skip vertical edges and the same edge
				{
					continue;
				}

				llong rightx = 0;
				llong leftx = 0;

				if (e[j].vtx1.x > e[j].vtx2.x)
				{
					rightx = e[j].vtx1.x;
					leftx = e[j].vtx2.x;
				}
				else
				{
					rightx = e[j].vtx2.x;
					leftx = e[j].vtx1.x;
				}
				

				if (e[j].vtx1.y > e[i].vtx1.y) // if the edge is above us
				{
					if (rightx >= ucoverright)
					{
						ucoverright = min(ucoverright, leftx);
					}
					else
					{
						ucoverleft = max(ucoverleft, rightx);
					}
				}
				else // ... below us
				{
					if (rightx >= dcoverright)
					{
						dcoverright = min(dcoverright, leftx);
					}
					else
					{
						dcoverleft = max(dcoverleft, rightx);
					}
				}
			}

			// unite "covers" and find the total covering

			int all = 0;

			if (ucoverright < ucoverleft) // top is covered
			{
				ucoverright = ninf;
				ucoverleft = pinf;
				all++;
			}
			
			if (dcoverright < dcoverleft)
			{
				dcoverleft = pinf;
				dcoverright = ninf;
				all++;
			}

			llong uncovered = max(ucoverright, dcoverright) - min(ucoverleft, dcoverleft);

			if (all == 2)
			{
				uncovered = 0;
			}

			if (uncovered <= 0)
			{
				ans += abs(e[i].vtx1.x - e[i].vtx2.x);
			}
			else
			{
				ans += (abs(e[i].vtx1.x - e[i].vtx2.x) - uncovered);
			}
		}
	}

	cout << ans;

	cout << endl;

#ifdef LOCAL_JUDGE
	timeStop = clock();

	cout << "Time elapsed: " << timeStop - timeStart << " ticks" << endl;
#endif

	return 0;
}