#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define ff first
#define ss second
#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define all(v) (v).begin(), (v).end()

using namespace std;

struct solver {
    int n, m;
    vector<vector<int> > graph;

    vector<int> h;
    vector<int> col;
    vector<int> up;
    vector<vector<pair<int, int> > > comps;
    vector<pair<int, int> > ces;
    void dfs(int u, int hg) {
        col[u] = 1;
        h[u] = hg;
        up[u] = h[u];
        for (int v : graph[u]) {
            if (h[v] == -1) {
                dfs(v, hg + 1);
                up[u] = min(up[u], up[v]);
                if (up[v] >= h[u]) {
                    comps.pb(vector<pair<int, int> >());
                    while (ces.size() && h[ces.back().ff] >= h[u]) {
                        comps.back().pb(ces.back());
                        ces.pop_back();
                    }
                }
            } else {
                if (col[v] == 1)
                    ces.pb(mp(v, u));
                up[u] = min(up[u], h[v]);
            }
        }
        col[u] = 2;
    }

    vector<map<int, vector<int> > > graphs;

    int curc = 1;
    vector<int> vis;
    vector<int> cycle_path;
    void find_cycle(int v, int par, int i) {
        cycle_path.pb(v);
        vis[v] = curc;
        for (int u : graphs[i][v]) {
            if (vis[u] != curc) {
                find_cycle(u, v, i);
            } else if (u != par) {
                return;
            }
        }
        cycle_path.pop_back();
    }

    int curc2 = 1;
    vector<int> onc;
    vector<int> path;
    void find_path(int v, int par, int i) {
        path.pb(v);
        vis[v] = curc;
        for (int u : graphs[i][v]) {
            if (vis[u] != curc) {
                if (onc[u] == curc2 && u != par) {
                    path.pb(u);
                    return;
                } else if (u != par)
                    find_path(u, par, i);
            }
        }
        path.pop_back();
    }

    solver() {}

    void solve() {
        cin >> n >> m;
        graph.resize(n);
        forn(i, m) {
            int u, v;
            cin >> u >> v;
            u--; v--;
            graph[u].pb(v);
            graph[v].pb(u);
        }

        h.resize(n, -1);
        up.resize(n, -1);
        col.resize(n);
        forn(i, n) {
            if (h[i] == -1) {
                dfs(i, 0);
            }
        }

        /*
        for (auto v : comps) {
            cout << v.size() << endl;
            for (auto p : v)
                cout << p.ff + 1 << " " << p.ss + 1 << endl;
        }
        cout << endl;
        */

        for (auto v : comps) {
            graphs.pb(map<int, vector<int> >());
            for (auto p : v) {
                graphs.back()[p.ff].pb(p.ss);
                graphs.back()[p.ss].pb(p.ff);
            }
        }

        vis.resize(n, 0);
        onc.resize(n, 0);
        forn(i, comps.size()) {
            if (comps[i].size() <= 3)
                continue;
            curc++;
            cycle_path.clear();
            find_cycle(comps[i][0].ff, -1, i);

            curc2++;
            for (int u : cycle_path) {
                onc[u] = curc2;
            }            

            int j = -1;
            for (int u : cycle_path) {
                j++;
                for (int v : graphs[i][u]) {
                    if (onc[v] != curc2) {                    
                        path = {u};
                        curc++;
                        find_path(v, u, i);
                        cout << u + 1 << " " << path.back() + 1 << endl;
                        cout << path.size() << " ";
                        for (int w : path)
                            cout << w + 1 << " ";
                        cout << endl;

                        vector<int> p2;
                        int k = j;
                        while (cycle_path[k] != path.back()) {
                            p2.pb(cycle_path[k]);
                            k--;
                            if (k < 0)
                                k = cycle_path.size() - 1;
                        }
                        p2.pb(path.back());

                        vector<int> p3;
                        k = j;
                        while (cycle_path[k] != path.back()) {
                            p3.pb(cycle_path[k]);
                            k++;
                            k %= cycle_path.size();
                        }
                        p3.pb(path.back());

                        cout << p2.size() << " ";
                        for (int w : p2)
                            cout << w + 1 << " ";
                        cout << endl;

                        cout << p3.size() << " ";
                        for (int w : p3)
                            cout << w + 1 << " ";
                        cout << endl;
                        return;
                    }
                }
            }
        }
        cout << -1 << endl;
    }
};

int main() {
    freopen("grand.in", "r", stdin);
#ifndef DEBUG                       
    freopen("grand.out", "w", stdout);
#endif
    
    int t;
    cin >> t;

    forn(_, t) {
        solver s;
        s.solve();
    }

    return 0;
}