#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e5;
vector<int> edge[maxn];
int p[maxn];
int dp[maxn];
int nx[maxn];
int sz[maxn];

void dfs(int u){
    dp[u] = 0;
    sz[u] = 1;
    nx[u] = -1;
    for (auto v: edge[u]){
        dfs(v);
        sz[u] += sz[v];
        dp[u] += dp[v];
        if (nx[u] == -1 && nx[v] == -1){
            nx[u] = v;
            nx[v] = u;
        }
    }
    if (nx[u] != -1) dp[u]++;
}

vector<int> q;

void add(int u){
    if (nx[u] == -1) q.push_back(u);
    for (auto v: edge[u]){
        add(v);
    }
}

int get(int u){
    return sz[u] - 2 * dp[u] - 2 * (nx[u] == -1);
}

bool cmp(int i, int j){
    return get(i) > get(j);
}

int main()
{
    #ifdef DEBUG
    freopen("input.txt", "r", stdin);
    #else
    freopen("hidden.in", "r", stdin);
    freopen("hidden.out", "w", stdout);
    #endif // DEBUG
    int n;
    cin >> n;
    fill(nx, nx + n, -1);
    vector<int> vt;
    vt.push_back(0);
    for (int i = 1; i < n; i++){
        cin >> p[i];
        p[i]--;
        if (p[i] == -1){
            vt.push_back(i);
        } else {
            edge[p[i]].push_back(i);
        }
    }
    for (auto v: vt){
        dfs(v);
    }
    sort(vt.begin() + 1, vt.end(), cmp);
    int ans = 0;
    for (auto v: vt){
        ans += dp[v];
        if (nx[v] == -1 && !q.empty()){
            ans++;
            nx[v] = q.back();
            nx[q.back()] = v;
            p[v] = q.back();
            q.pop_back();
        } else {
            p[v] = 0;
        }
        add(v);
    }
    cout << ans << "\n";
    for (int i = 1; i < n; i++){
        cout << p[i] + 1 << " ";
    }
    return 0;
}
