#include <iostream>
#include <fstream>
#include "math.h"
using namespace std;

bool isPossible(int h, int w, long n, int lines_w, int lines_h){
    long tmp = w * h - lines_h * w - lines_w * h + lines_h * lines_w;
    return (tmp != 0) && (tmp / n != 0 ) && ((lines_w + 1)*(lines_h + 1) == n) ;
}

void draw(int h, int w, int lines_w, int lines_h, ofstream *out){
    char island[h][w];
    for (int j = 0; j < h; ++j) {
        for (int i = 0; i < w; ++i) {
            island[j][i] = '.';
        }
    }

    for (int i = 1; i < w && lines_w > 0 ; i += 2, lines_w--) {
        for (int j = 0; j < h; ++j) {
            island[j][i] = '#';
        }
    }

    for (int i = 1; i < h && lines_h > 0 ; i += 2, lines_h--) {
        for (int j = 0; j < w; ++j) {
            island[i][j] = '#';
        }
    }

    for (int j = 0; j < h; ++j) {
        for (int i = 0; i < w; ++i) {
            *out << island[j][i];
        }
        *out << endl;
    }
}


int main() {
    ifstream in;
    in.open("kotlin.in", ios_base::in);
    int h, w;
    long n;
    in >> h >> w >> n;
    in.close();

    ofstream out;
    out.open("kotlin.out", ios_base::out);

    for (int lines_w = 0; lines_w <= ceil(w / 2.0) - 1 ; ++lines_w) {
        for (int lines_h = 0; lines_h <= ceil(h / 2.0) - 1; ++lines_h) {
            if (isPossible(h, w, n, lines_w, lines_h)){
                draw(h, w, lines_w, lines_h, &out);
                return 0;
            }
        }
    }

    out << "Impossible" << endl;
    out.close();
    return 0;
}