#include <fstream>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

struct variable {
	char symbol;
	int type = -1;
};

int find(vector <variable>& vars, char symbol) {
	for (int i = 0; i < vars.size(); i++) {
		if (vars.at(i).symbol == symbol)
			return i;
	}
	return -1;
}

void parse(vector <variable>& vars, string formula) {
	int nextIsTrue = 0;
	for (int i = 0; i < formula.length(); i++) {
		if (formula[i] != '|') 
			if (formula[i] == '~') {
				nextIsTrue = 1;
			}
			else {
				int pos = find(vars, formula[i]);
				if (pos == -1) 
					vars.push_back(variable{ formula[i], nextIsTrue });
				else {
					if (vars.at(pos).type != nextIsTrue)
						vars.at(pos).type = 2;
				}
				nextIsTrue = 0;
			}
		
	}
}

unsigned long long calc(vector <variable>& vars) {
	int c1 = 0;
	int c2 = 0;
	for (int i = 0; i < vars.size(); i++) {
		if (vars.at(i).type == 2)
			c1++;
		else
			c2++;
	}
	//cout << "c1: " << c1 << " c2: " << c2 << endl;
	unsigned long long res = 0;
	if (c1 == 0) {
		for (int i = 0; i < c2; i++) {
			res += pow(2, i);
			
		}
	}
	else {
		res = pow(2, (c1 + c2));
	}
	//cout << res << endl;
	return res;
}

int main() {

	vector <variable> vars;

	ifstream in("boolean.in");
	ofstream out("boolean.out");

	string formula;
	in >> formula;
	parse(vars, formula);
	//for (int i = 0; i < vars.size(); i++) {
	//	auto v = vars.at(i);
	//	cout << v.type << v.symbol << " ";
	//}
	//cout << endl;
	out << calc(vars);
	//system("pause");
	return 0;
}