#include <iostream>
#include <cstdio>
#include <cmath>
#include <set>
typedef unsigned long long ull;
typedef long double ld;
using namespace std;
struct row
{
    int deg, a;
    ull p, q;
    row(int _deg, ull _p, ull _q,int _a)
    {
        deg=_deg;p=_p;q=_q;a=_a;
    }
    bool operator<(const row &x) const {
        return x.deg < deg  || a<x.a || (a == x.a == deg && p < x.p)
                || (a == x.a == 0 && q < x.q);
    }
};

ull n = 1e18, kmax;
set<row> vars;
void tryit(ull p, ull q, int k)
{
    int a = -1;
    for (int i = 0; i <= k; i++)
    {
        if (powl(p, i) * powl(q, k-i) == n)
        {
            a = i;
            break;
        }
    }
    if (a>=0)
    {
        row ans(k, p, q, a);
        vars.insert(ans);
    }
}
int main() {
    freopen("little.in", "r", stdin);
    freopen("little.out", "w", stdout);
    std::cin >> n;
    if (n <= 2)
    {
        cout << "-1";
        return 0;
    }

    kmax = ull(log2(n));
    for (int k = 1; k <= kmax; k++)
    {
        int a = -1;
        long double root = pow((long double)n, (long double)1/k);
        ull p = ull(floor(root)),
            q = ull(ceil(root));
        if (p==q)
        {
            row ans(k, p, p, k);
            vars.insert(ans);
        }
        else
        {
            tryit(p,q,k);
            tryit(p-1,q,k);
//            tryit(p-1,q+1,k);
            tryit(p,q+1,k);
        }
    }
    cout << vars.size() << endl;
    for (auto ans : vars)
    {
        cout << ans.deg;
        for (int i = 0; i < ans.deg; ++i)
            cout << ' ' << (i < ans.a ? ans.p : ans.q);
        cout << endl;
    }
    return 0;
}