#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <set>
#include <vector>
#include <cassert>

using namespace std;
typedef long long ll;
typedef pair <ll, ll> par;

ll x[1010];
ll y[1010];
int n;

bool hor(int q) {
	if (q == n - 1) return y[n - 1] == y[0];
	return y[q] == y[q + 1];
}

bool vert(int q) {
	if (q == n - 1) return x[n - 1] == x[0];
	return x[q] == x[q + 1];
}

par side(int q) {
	int a, b;
	if (q == n - 1) {
		a = n - 1;
		b = 0;
	}
	else {
		a = q;
		b = q + 1;
	}
	par res;
	if (x[a] == x[b]) res = { y[a], y[b] }; else res = { x[a], x[b] };
	if (res.first > res.second) swap(res.first, res.second);
	return res;
}

bool operator < (par const& a, par const& b) {
	if (a.first != b.first) return a.first < b.first;
	return a.second < b.second;
}

par interject(par a, par b) {
	par res;
	res.first = max(a.first, b.first);
	res.second = min(a.second, b.second);
	if (res.first > res.second) return { 0, 0 };
	return res;
}

vector <par> un(vector <par> & a, par sd) {
	vector <par> res;
	res.clear();
	for (par c : a) res.push_back(interject(c, sd));
	return res;
}

vector <par> shr(vector <par> & a) {
	vector <par> res;
	res.clear();
	if (a.empty()) return res; else {
		ll l = a[0].first, r = a[0].second;
		for (int i = 1; i < a.size(); i++) {
			if (a[i].first <= r) r = max(r, a[i].second); else {
				if (l < r) res.push_back({ l, r });
				l = a[i].first;
				r = a[i].second;
			}
		}
		if (l < r) res.push_back({ l, r });
	}
	return res;
}

ll const INF = 1e9;


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("intel.in", "r", stdin);
	freopen("intel.out", "w", stdout);
#endif // _DEBUG
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> x[i] >> y[i];
	}
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		vector <par> lc;
		vector <par> rc;
		for (int j = 0; j < n; j++) if (i != j) {
			if (hor(i) && hor(j)) {
				par b = side(j);
				if (y[j] < y[i]) lc.push_back(b);
				if (y[j] > y[i]) rc.push_back(b);
			}
			if (vert(i) && vert(j)) {
				par b = side(j);
				if (x[j] < x[i]) lc.push_back(b);
				if (x[j] > x[i]) rc.push_back(b);
			}
		}
		sort(lc.begin(), lc.end());
		sort(rc.begin(), rc.end());
		par a = side(i);
		vector <par> lc1, rc1;
		lc1 = un(lc, a);
		rc1 = un(rc, a);
		lc = shr(lc1), rc = shr(rc1);
		sort(lc.begin(), lc.end());
		sort(rc.begin(), rc.end());
		par le, re;
		le = re = a;
		assert(lc.size() < 3 && rc.size() < 3);
		if (lc.empty() || rc.empty()) {
			continue;
		}
		for (int i = 0; i < lc.size(); i++) {
			assert(!(a.first < lc[i].first && lc[i].second < a.second));
			if (lc[i].first <= a.first) le.first = lc[i].second;
			if (lc[i].second >= a.second) le.second = lc[i].first;
		}
		for (int i = 0; i < rc.size(); i++) {
			assert(!(a.first < rc[i].first && rc[i].second < a.second));
			if (rc[i].first <= a.first) re.first = rc[i].second;
			if (rc[i].second >= a.second) re.second = rc[i].first;
		}
		par res;
		res.first = min(le.first, re.first);
		res.second = max(le.second, re.second);
		ll nw = 0;
		nw += max(0LL, res.first - side(i).first);
		nw += max(0LL, side(i).second - res.second);
		nw = min(side(i).second - side(i).first, nw);
		ans += nw;
	}
	cout << ans;
	return 0;
}