#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <set>
#include <vector>
#include <cassert>

using namespace std;
typedef long long ll;
typedef pair <ll, ll> par;

ll x[1010];
ll y[1010];
int n;

bool hor(int q) {
	if (q == n - 1) return y[n - 1] == y[0];
	return y[q] == y[q + 1];
}

bool vert(int q) {
	if (q == n - 1) return x[n - 1] == x[0];
	return x[q] == x[q + 1];
}

par side(int q) {
	int a, b;
	if (q == n - 1) {
		a = n - 1;
		b = 0;
	}
	else {
		a = q;
		b = q + 1;
	}
	par res;
	if (x[a] == x[b]) res = { y[a], y[b] }; else res = { x[a], x[b] };
	if (res.first > res.second) swap(res.first, res.second);
	return res;
}

bool operator < (par const& a, par const& b) {
	if (a.first != b.first) return a.first < b.first;
	return a.second < b.second;
}

par interject(par a, par b) {
	par res;
	res.first = max(a.first, b.first);
	res.second = min(a.second, b.second);
	if (res.first > res.second) return { 0, 0 };
	return res;
}

vector <par> un(vector <par> & a, par sd) {
	vector <par> res;
	res.clear();
	for (par c : a) {
		par q = interject(c, sd);
		if (q.first != q.second); res.push_back(interject(c, sd));
	}
	return res;
}

vector <par> shr(vector <par> & a) {
	vector <par> res;
	res.clear();
	if (a.empty()) return res; else {
		ll l = a[0].first, r = a[0].second;
		for (int i = 1; i < a.size(); i++) {
			if (a[i].first <= r) r = max(r, a[i].second); else {
				if (l < r) res.push_back({ l, r });
				l = a[i].first;
				r = a[i].second;
			}
		}
		if (l < r) res.push_back({ l, r });
	}
	return res;
}

int const INF = 1e9;

vector <par> merge(vector <par> & a, vector <par> & b) {
	vector <par> res;
	vector <par> line;
	res.clear();
	line.clear();
	for (par c : a) {
		line.push_back({ c.first, 0 });
		line.push_back({ c.second, 2 });
	}
	for (par c : b) {
		line.push_back({ c.first, 1 });
		line.push_back({ c.second, 3 });
	}
	sort(line.begin(), line.end());
	int d[2] = { 0, 0 };
	int prev = -INF;
	for (par c : line) {
		if (c.second == 0) {
			assert(!d[0]);
			d[0]++;
		}
		if (c.second == 1) {
			assert(!d[1]);
			d[1]++;
		}
		if (c.second == 2) {
			assert(d[0] == 1);
			if (d[0] && d[1]) {
				res.push_back({ prev, c.first });
			}
			d[0]--;
		}
		if (c.second == 3) {
			assert(d[1] == 1);
			if (d[0] && d[1]) {
				res.push_back({ prev, c.first });
			}
			d[1]--;
		}
		prev = c.first;
	}
	return res;
}


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("intel.in", "r", stdin);
	freopen("intel.out", "w", stdout);
#endif // _DEBUG
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> x[i] >> y[i];
	}
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		vector <par> lc;
		vector <par> rc;
		for (int j = 0; j < n; j++) if (i != j) {
			if (hor(i) && hor(j)) {
				par b = side(j);
				if (y[j] < y[i]) lc.push_back(b);
				if (y[j] > y[i]) rc.push_back(b);
			}
			if (vert(i) && vert(j)) {
				par b = side(j);
				if (x[j] < x[i]) lc.push_back(b);
				if (x[j] > x[i]) rc.push_back(b);
			}
		}
		sort(lc.begin(), lc.end());
		sort(rc.begin(), rc.end());
		lc = shr(lc), rc = shr(rc);
		lc = un(lc, side(i)), rc = un(rc, side(i));
		sort(lc.begin(), lc.end());
		sort(rc.begin(), rc.end());
		vector <par> res = merge(lc, rc);
		res = shr(res);
		for (par c : res) ans += (c.second - c.first);
	}
	cout << ans;
	return 0;
}