#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <set>
#include <vector>

using namespace std;
typedef long long ll;
typedef pair <int, int> par;

struct block {
	long long a, b, c, d;
	block(long long A, long long B, long long C, long long D) {
		a = A;
		b = B;
		c = C;
		d = D;
	}
};

vector <block> ans;

long long find_sqrt2(long long arg) {
	long long l = 0, r = 1000000001;
	while (l + 1 < r) {
		long long mid = (l + r) / 2;
		if (mid *mid >= arg) {
			r = mid;
		}
		else {
			l = mid;
		}
	}
	return r;
}

pair <long long, long long> find_log(long long arg, long long p) {
	long long buf = arg;
	long long res = 0, res2 = 1;
	while (buf % p == 0) {
		buf /= p;
		res++;
		res2 *= p;
	}
	return make_pair(res, arg / res2);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("little.in", "r", stdin);
	freopen("little.out", "w", stdout);
#endif // _DEBUG
	long long n;
	cin >> n;
	if (n == 1 || n == 2) {
		cout << -1;
		return 0;
	}
	long long t = find_sqrt2(n);
	if (n <= 1000000) {
		for (long long i = 2; i * i <= n; i++) {
			pair <long long, long long> a = find_log(n, i);
			if (a.first != 0) {
				if (a.second == 1) {
					if (i == 2) {
						cout << -1;
						return 0;
					}
					ans.push_back(block(i, 1, a.first, 0));
				}
				else {
					pair <long long, long long> b = find_log(a.second, i + 1);
					if (b.second == 1) {
						ans.push_back(block(i, i + 1, a.first, b.first));
					}
				}
			}
		}
	}
	else {
		return 1;
		for (long long i = 2; i * i * i <= n; i++) {
			pair <long long, long long> a = find_log(n, i);
			if (a.first != 0) {
				if (a.second == 1) {
					if (i == 2) {
						cout << -1;
						return 0;
					}
					ans.push_back(block(i, 1, a.first, 0));
				}
				else {
					pair <long long, long long> b = find_log(a.second, i + 1);
					if (b.second == 1) {
						ans.push_back(block(i, i + 1, a.first, b.first));
					}
				}
			}
		}
		if (t * t == n) {
			ans.push_back(block(t, 1, 2, 0));
		}
	}
	ans.push_back(block(n, 1, 1, 0));
	cout << ans.size() << endl;
	for (auto i : ans) {
		cout << i.c + i.d << ' ';
		for (int j = 0; j < i.c; j++) {
			cout << i.a << ' ';
		}
		for (int j = 0; j < i.d; j++) {
			cout << i.b << ' ';
		}
		cout << endl;
	}
	return 0;
}