package com.company;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Locale;
import java.util.Scanner;

public class ProblemB {

    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        Scanner sc = null;
        try {
            // Input
            sc = new Scanner(new File("boolean.in"));
            String line = sc.nextLine();
            sc.close();

            // Logic
            int[] positive = new int[52];
            int[] negative = new int[52];

            boolean nextNegative = false;

            int result = 0;
            int variables = 0;

            for(int i = 0; i < line.length(); i++){
                char c = line.charAt(i);
                if(c == '|'){
                    continue;
                }
                else if(c == '~'){
                    nextNegative = true;
                }
                else{
                    int id = getCharID(c);
                    if(nextNegative){
                        if(positive[id] == 0 && negative[id] == 0){
                            variables++;
                        }
                        negative[id] = 1;
                        nextNegative = false;
                    }
                    else {
                        if(positive[id] == 0 && negative[id] == 0){
                            variables++;
                        }
                        positive[id] = 1;
                    }

                    if(positive[id] == 1 && negative[id] == 1){
                        result = 1;
                    }
                }
            }

            result += Math.pow(2, variables) - 1;

            // Output
            PrintWriter pw = new PrintWriter(new File("boolean.out"));
            pw.print(result);
            pw.close();

        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    static int getCharID(char c){
        return ((int)c >= 97)?((int)c - 97 + 26):((int)c - 65);
    }
}
