package com.company;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class ProblemK {

    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        Scanner sc = null;
        try {
            // Input
            sc = new Scanner(new File("kotlin.in"));
            int h = sc.nextInt();
            int w = sc.nextInt();
            long n = sc.nextInt();
            sc.close();

            // Logic

            char[][] grid = new char[w][];
            for(int x = 0; x < w; x++){
                grid[x] = new char[h];
                for(int y = 0; y < h; y++){
                    grid[x][y] = '.';
                }
            }

            long islands = 1;

            int verticalDivisions = (int)(w/2.0 + 0.5) - 1;
            if(verticalDivisions < 0){ verticalDivisions = 0; }

            int horizontalDivisions = (int)(h/2.0 + 0.5) - 1;
            if(horizontalDivisions < 0){ horizontalDivisions = 0; }

            long islandsVertical = 1;
            long islandsHorizontal = 1;

            int horizontalDivisionID = 1;
            int verticalDivisionID = 1;

            while((islands < n) && ((verticalDivisions > 0) || (horizontalDivisions > 0))){
                long expectedResultVertical = islands + islandsVertical;
                long expectedResultHorizontal = islands + islandsHorizontal;

                long differenceVertical = n - expectedResultVertical;
                long differenceHorizontal = n - expectedResultHorizontal;

                boolean verticalDivision =
                        (differenceVertical < differenceHorizontal) || (horizontalDivisions <= 0);

                if(verticalDivision && (verticalDivisions > 0)){
                    verticalDivisions--;
                    for(int i = 0; i < h; i++){
                        grid[verticalDivisionID][i] = '#';
                    }
                    verticalDivisionID += 2;

                    islands += islandsVertical;
                    islandsHorizontal += 1; //islandsVertical;
                }
                else if(horizontalDivisions > 0){
                    horizontalDivisions--;
                    for(int i = 0; i < w; i++){
                        grid[i][horizontalDivisionID] = '#';
                    }
                    horizontalDivisionID += 2;

                    islands += islandsHorizontal;
                    islandsVertical += 1; //islandsHorizontal;
                }
            }

            // Output
            if(islands < n){
                // Impossible!
                PrintWriter pw = new PrintWriter(new File("kotlin.out"));
                pw.print("Impossible");
                pw.close();
            }
            else{
                if(islands > n){
                    if(islands - islandsVertical == n){
                        for(int i = 0; i < h; i++){
                            grid[0][i] = '#';
                        }
                    }
                    else if(islands - islandsHorizontal == n){
                        for(int i = 0; i < w; i++){
                            grid[i][0] = '#';
                        }
                    }
                    else{
                        PrintWriter pw = new PrintWriter(new File("kotlin.out"));
                        pw.print("Impossible");
                        pw.close();
                        return;
                    }
                }

                PrintWriter pw = new PrintWriter(new File("kotlin.out"));
                for(int y = 0; y < h; y++) {
                    for (int x = 0; x < w; x++) {
                        pw.print(grid[x][y]);
                    }
                    pw.println();
                }
                pw.close();
            }
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }
}
