package com.company;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class ProblemKSecondTry {

    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        Scanner sc = null;
        try {
            // Input
            sc = new Scanner(new File("kotlin.in"));
            int h = sc.nextInt();
            int w = sc.nextInt();
            long n = sc.nextLong();
            sc.close();

            // Logic

            char[][] grid = new char[w][];
            for(int x = 0; x < w; x++){
                grid[x] = new char[h];
                for(int y = 0; y < h; y++){
                    grid[x][y] = '#';
                }
            }


            int verticalDivisions = (int)(w/2.0 + 0.5) - 1;
            if(verticalDivisions < 0){ verticalDivisions = 0; }

            int horizontalDivisions = (int)(h/2.0 + 0.5) - 1;
            if(horizontalDivisions < 0){ horizontalDivisions = 0; }


            int possibleIslandsVertical = verticalDivisions + 1;
            int possibleIslandsHorizontal = horizontalDivisions + 1;

//            a * b = n;
//            a <= possibleIslandsHorizontal;
//            b <= possibleIslandsVertical;
//            n <= possibleIslandsHorizontal*possibleIslandsVertical;

            for(long a = 1; a <= possibleIslandsHorizontal; a++){
                long b = n / a;
                if(n % a == 0 && b <= possibleIslandsVertical){

                    for(int y = 0; y < b; y++) {
                        for (int x = 0; x < a; x++) {
                            grid[x*2][y*2] = '.';
                        }
                    }

                    PrintWriter pw = new PrintWriter(new File("kotlin.out"));
                    for(int y = 0; y < h; y++) {
                        for (int x = 0; x < w; x++) {
                            pw.print(grid[x][y]);
                        }
                        pw.println();
                    }
                    pw.close();
                    return;
                }
            }


            // Impossible!
            PrintWriter pw = new PrintWriter(new File("kotlin.out"));
            pw.print("Impossible");
            pw.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }
}
