#include <fstream>
#include <vector>
#include <cmath>

using namespace std;

ifstream cin("little.in");
ofstream cout("little.out");

int main() {
    long long n;
    cin >> n;

    long long n0 = n, c1 = 0, c2 = 0;
    while (n0 % 2 == 0)
        n0 /= 2;
    if (n0 == 1) {
        cout << -1;
        return 0;
    }

    vector<vector<long long>> lists;

    for (long long i = 2; i * i * i <= n; i++) {
        n0 = n;
        c1 = c2 = 0;
        while (n0 % i == 0) {
            n0 /= i;
            c1++;
        }
        while (n0 % (i + 1) == 0) {
            n0 /= (i + 1);
            c2++;
        }
        if (n0 == 1 && c1 > 0) {
            lists.push_back(vector<long long>());
            while (c1--)
                lists.back().push_back(i);
            while (c2--)
                lists.back().push_back(i + 1);
        }
    }

    long long i = (long long)sqrtl(n);
    if (i <= 1000000 && i * i * i > n) {
        n0 = n;
        c1 = c2 = 0;
        while (n0 % i == 0)
            n0 /= i, c1++;
        while (n0 % (i + 1) == 0)
            n0 /= (i + 1), c2++;

        if (n0 == 1) {
            lists.push_back(vector<long long>());
            while (c1--)
                lists.back().push_back(i);
            while (c2--)
                lists.back().push_back(i + 1);
        }
    }

    lists.push_back({n});

    cout << lists.size() << endl;
    for (auto& lst: lists) {
        cout << lst.size() << ' ';
        for (auto& item: lst)
            cout << item << ' ';
        cout << endl;
    }
    return 0;
}
