import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.*;

public class Main {
    public static void main(String[] arguments) throws IOException {
        Scanner sc = new Scanner(new FileReader("intel.in"));
        PrintWriter pw = new PrintWriter(new FileWriter("intel.out"));

        int n = sc.nextInt();

        List<Integer>
                x_beg = new ArrayList<>(),
                x_end = new ArrayList<>(),
                y_beg = new ArrayList<>(),
                y_end = new ArrayList<>();

        int prev_x = sc.nextInt(), prev_y = sc.nextInt();
        int first_x = prev_x, first_y = prev_y;

        for (int i = 1; i < n; i++) {
            int x2 = sc.nextInt(), y2 = sc.nextInt();
            if (prev_x == x2) {
                y_beg.add(prev_y < y2 ? prev_y : y2);
                y_end.add(prev_y < y2 ? y2 : prev_y);
            } else {
                x_beg.add(prev_x < x2 ? prev_x : x2);
                x_end.add(prev_x < x2 ? x2 : prev_x);
            }
            prev_x = x2;
            prev_y = y2;
        }

        if (prev_x == first_x) {
            y_beg.add(prev_y < first_y ? prev_y : first_y);
            y_end.add(prev_y < first_y ? first_y : prev_y);
        } else {
            x_beg.add(prev_x < first_x ? prev_x : first_x);
            x_end.add(prev_x < first_x ? first_x : prev_x);
        }

        Comparator<Integer> comp = new Comparator<Integer>() {
            @Override
            public int compare(Integer o1, Integer o2) {
                return o1 > o2 ? 1 : (o1 < o2 ? -1 : 0);
            }
        };

        x_beg.sort(comp);
        x_end.sort(comp);
        y_beg.sort(comp);
        y_end.sort(comp);

        int result = 0;
        result += count(x_beg, x_end);
        result += count(y_beg, y_end);

        pw.write(result + "");

        sc.close();
        pw.close();
    }

    private static int count(List<Integer> set_beg, List<Integer> set_end) {
        int result = 0;
        int count = 0;
        int[]
                begs = toIntArr(set_beg),
                ends = toIntArr(set_end);

        ArrayList<Point> points = new ArrayList<>();

        int prev = begs[0];
        points.add(new Point(begs[0], -1, 0));
        for (int b : begs) {
            if (points.size() > 0 && b == prev)
                points.get(points.size() - 1).begin++;
            else
                points.add(new Point(b, 1, 0));
        }

        int i_p = 0;
        for (int e : ends) {
            if(points.get(i_p).coord == e)
                points.get(i_p).end++;
            else {
                while (i_p < points.size() && points.get(i_p).coord < e) {
                    i_p++;
                }
                if (i_p < points.size() &&  points.get(i_p).coord == e)
                    points.get(i_p).end++;
                else
                    points.add(i_p, new Point(e, 0, 1));
            }
        }

        int prev_coord = points.get(0).coord;
        for (Point p : points) {
            if (count > 2) result += (count - 2) * (p.coord - prev_coord);
            count -= p.end;
            count += p.begin;
        }

        return result;
    }


    static int[] toIntArr(List<Integer> set) {
        int[] tmp = new int[set.size()];
        int i = 0;
        for (Integer t : set) {
            tmp[i] = t;
            i++;
        }
        return tmp;
    }

    static class Point {
        int begin = 0;
        int end = 0;
        int coord;

        public Point (int c, int b ,int e) {
            coord = c;
            begin = b;
            end = e;

        }
        public Point (int b ,int e) {
            begin = b;
            end = e;
        }
    }
}
