#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <string>
#include <unordered_set>

using namespace std;

void solve (istream &cin, ostream &cout)
{
    string str;

    cin >> str;

    unordered_set<string> used;

    int prev = 0;

    while (prev != string::npos)
    {
        int tmp = str.find ('|', prev);

        if (tmp == -1)
            used.insert (str.substr (prev));
        else
            used.insert (str.substr (prev, tmp - prev));

        if (tmp == -1)
            prev = tmp;
        else
            prev = tmp + 1;
    }

    int cnt = 0;

    for (char c = 'a'; c <= 'z'; c++)
    {
        string a = "";
        a += c;
        auto b = '~' + a;

        if (used.count (a) &&
            used.count (b))
            cnt++;
    }

    for (char c = 'A'; c <= 'Z'; c++)
    {
        string a = "";
        a += c;
        auto b = '~' + a;

        if (used.count (a) &&
            used.count (b))
            cnt++;
    }

    long long ans = 1ll << (used.size () - cnt);

    if (cnt == 0)
        ans--;

    cout << ans << endl;
}

int main ()
{
    const string filename = "boolean";

    ifstream fin (filename + ".in");

    if (fin.fail ())
        solve (cin, cout);
    else
    {
        ofstream fout (filename + ".out");

        solve (fin, fout);
    }

    return 0;
}
