#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <string>
#include <unordered_set>
#include <set>
#include <unordered_map>
#include <map>

#pragma comment(linker,"/STACK:200000000")

using namespace std;

const int inf = (int)1e9 + 7;

int cnt1 (int n)
{
    return n ? 1 + cnt1 (n & (n - 1)) : 0;
}

int logib (int n)
{
    int r = 0;

    while ((1 << r) <= n)
        r++;

    return r;
}

void output (vector<vector<int>> &ans, int a, int b, int c)
{
    ans.push_back ({ a, b, c });
}

void outtie (vector<vector<int>> &ans, int num)
{
    while (num > 1)
        if (num & 1)
        {
            output (ans, num, num - 1, 1);
            num--;
        }
        else
        {
            output (ans, num, num / 2, num / 2);
            num /= 2;
        }
}

void solveD (istream &cin, ostream &cout)
{
    int t;

    cin >> t;

    for (int i = 0; i < t; i++)
    {
        vector<vector<int>> ans;

        vector<int> arr (4);

        for (auto &it : arr)
            cin >> it;

        int num = 0;

        for (auto it : arr)
            num += 1 << it;

        int ones = cnt1 (num), l = logib (num);

        if (ones < 4)
        {
            outtie (ans, num);
        }
        else
        {
            sort (arr.begin (), arr.end ());

            if (arr[1] - arr[0] == arr[3] - arr[2])
            {
                while (num % 2 == 0)
                {
                    output (ans, num, num / 2, num / 2);
                    num /= 2;
                }

                int car = 1 + (1 << (arr[1] - arr[0]));

                output (ans, num, car, num - car);

                num -= car;

                outtie (ans, num);
            }
            else
            {
                if (arr[1] - arr[0] == arr[3] - arr[2] + 1)
                {
                    while (num % 2 == 0)
                    {
                        output (ans, num, num / 2, num / 2);
                        num /= 2;
                    }

                    int car = 1 + (1 << (arr[1] - arr[0]));

                    output (ans, num, car, num - car);

                    num -= car;

                    while (num % 2 == 0)
                    {
                        output (ans, num, num / 2, num / 2);
                        num /= 2;
                    }

                    output (ans, car, num, car - num);

                    outtie (ans, num);
                }
                else
                {
                    if (arr[1] - arr[0] == arr[3] - arr[2] - 1)
                    {
                        while (num % 2 == 0)
                        {
                            output (ans, num, num / 2, num / 2);
                            num /= 2;
                        }

                        int car = 1 + (1 << (arr[1] - arr[0]));

                        output (ans, num, car, num - car);

                        num -= car;

                        while (num % 2 == 0)
                        {
                            output (ans, num, num / 2, num / 2);
                            num /= 2;
                        }

                        output (ans, num, car, num - car);

                        outtie (ans, car);
                    }
                    else
                    {
                        if (arr[1] - arr[0] == 1 && arr[3] - arr[2] == 3)
                        {
                            while (num % 2 == 0)
                            {
                                output (ans, num, num / 2, num / 2);
                                num /= 2;
                            }
                            output (ans, num, 3, num - 3);
                            num -= 3;
                            while (num % 2 == 0)
                            {
                                output (ans, num, num / 2, num / 2);
                                num /= 2;
                            }
                            output (ans, 9, 6, 3);
                            output (ans, 6, 3, 3);
                            output (ans, 3, 2, 1);
                            output (ans, 2, 1, 1);
                        }
                        else
                        {
                            if (arr[1] - arr[0] == 3 && arr[3] - arr[2] == 1)
                            {
                                while (num % 2 == 0)
                                {
                                    output (ans, num, num / 2, num / 2);
                                    num /= 2;
                                }
                                output (ans, num, 9, num - 9);
                                num -= 9;
                                while (num % 4 == 0)
                                {
                                    output (ans, num, num / 2, num / 2);
                                    num /= 2;
                                }
                                output (ans, 9, 6, 3);
                                output (ans, 3, 2, 1);
                                output (ans, 2, 1, 1);
                            }
                            else
                            {
                                outtie (ans, num);
                            }
                        }
                    }
                }
            }
        }

        cout << ans.size () << endl;

        for (const auto &row : ans)
            cout << row[0] << ' ' << row[1] << ' ' << row[2] << endl;
    }
}

pair<int, int> foo (const vector<vector<int>> &gr, int v, bool used)
{
    static vector<vector<pair<int, int>>> dp (2,
        vector<pair<int, int>> (gr.size (), { -1, -1 }));

    if (dp[used][v].first == -1)
        if (used)
        {
            dp[used][v].first = 0;

            for (auto it : gr[v])
                dp[used][v].first += foo (gr, it, false).first;
        }
        else
        {
            auto sum = (dp[used][v] = foo (gr, v, true));

            for (int i = 0; i < gr[v].size (); i++)
                dp[used][v] = max (dp[used][v], { sum.first +
                    foo (gr, gr[v][i], true).first -
                    foo (gr, gr[v][i], false).first + 1, i });
        }

    return dp[used][v];
}

int dfs (const vector<vector<int>> &gr, vector<bool> &app, int v, bool used)
{
    int ret = 0;

    auto tmp = foo (gr, v, used);

    if (!used && tmp.second == -1)
    {
        app[v] = true;
        ret = 1;
    }

    for (int i = 0; i < gr[v].size (); i++)
        ret += dfs (gr, app, gr[v][i], i == tmp.second);

    return ret;
}

void solve (istream &cin, ostream &cout)
{
    int n;

    cin >> n;

    vector<vector<int>> gr (n);
    vector<int> roots = {0};

    for (int i = 1; i < n; i++)
    {
        int p;

        cin >> p;
        p--;

        if (p != -1)
            gr[p].push_back (i);
        else
            roots.push_back (i);
    }

    int ans = 0;
    vector<int> emp, oth;

    for (auto it : roots)
    {
        ans += foo (gr, it, false).first;

        (foo (gr, it, false).first == foo (gr, it, true).first ?
            emp : oth).push_back (it);
    }

    vector<bool> app (n);

    for (auto it : emp)
        dfs (gr, app, it, false);

    for (auto it : oth)
        dfs (gr, app, it, true);

    for (auto it : emp)
        app[it] = false;
}

int main ()
{
    const string filename = "dividing";

    ifstream fin (filename + ".in");

    if (fin.fail ())
        solveD (cin, cout);
    else
    {
        ofstream fout (filename + ".out");

        solveD (fin, fout);
    }

    return 0;
}
