#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <string>
#include <unordered_set>
#include <set>
#include <unordered_map>
#include <map>

#pragma comment(linker,"/STACK:200000000")

using namespace std;

const int inf = (int)1e9 + 7;

int cnt1 (int n)
{
    return n ? 1 + cnt1 (n & (n - 1)) : 0;
}

int logib (int n)
{
    int r = 0;

    while ((1 << r) <= n)
        r++;

    return r;
}

void output (vector<vector<int>> &ans, int a, int b, int c)
{
    ans.push_back ({ a, b, c });
}

void outtie (vector<vector<int>> &ans, int num)
{
    while (num > 1)
        if (num & 1)
        {
            output (ans, num, num - 1, 1);
            num--;
        }
        else
        {
            output (ans, num, num / 2, num / 2);
            num /= 2;
        }
}

void solveD (istream &cin, ostream &cout)
{
    int t;

    cin >> t;

    for (int i = 0; i < t; i++)
    {
        vector<vector<int>> ans;

        vector<int> arr (4);

        for (auto &it : arr)
            cin >> it;

        int num = 0;

        for (auto it : arr)
            num += 1 << it;

        int ones = cnt1 (num), l = logib (num);

        if (ones < 4)
        {
            outtie (ans, num);
        }
        else
        {
            sort (arr.begin (), arr.end ());

            if (arr[1] - arr[0] == arr[3] - arr[2])
            {
                while (num % 2 == 0)
                {
                    output (ans, num, num / 2, num / 2);
                    num /= 2;
                }

                int car = 1 + (1 << (arr[1] - arr[0]));

                output (ans, num, car, num - car);

                num -= car;

                outtie (ans, num);
            }
            else
            {
                if (arr[1] - arr[0] == arr[3] - arr[2] + 1)
                {
                    while (num % 2 == 0)
                    {
                        output (ans, num, num / 2, num / 2);
                        num /= 2;
                    }

                    int car = 1 + (1 << (arr[1] - arr[0]));

                    output (ans, num, car, num - car);

                    num -= car;

                    while (num % 2 == 0)
                    {
                        output (ans, num, num / 2, num / 2);
                        num /= 2;
                    }

                    output (ans, car, num, car - num);

                    outtie (ans, car);
                }
                else
                {
                    if (arr[1] - arr[0] == arr[3] - arr[2] - 1)
                    {
                        while (num % 2 == 0)
                        {
                            output (ans, num, num / 2, num / 2);
                            num /= 2;
                        }

                        int car = 1 + (1 << (arr[1] - arr[0]));

                        output (ans, num, car, num - car);

                        num -= car;

                        while (num % 2 == 0)
                        {
                            output (ans, num, num / 2, num / 2);
                            num /= 2;
                        }

                        output (ans, num, car, num - car);

                        outtie (ans, num);
                    }
                    else
                    {
                        if (arr[1] - arr[0] == 1 && arr[3] - arr[2] == 3)
                        {

                        }
                    }
                }
            }
        }

        cout << ans.size () << endl;

        for (const auto &row : ans)
            cout << row[0] << ' ' << row[1] << ' ' << row[2] << endl;
    }
}

void foo (vector<int> &ans, const vector<int> &all)
{
    int t = 0;

    for (int i = 0; i < ans.size (); i++)
    {
        while (t < all.size () && all[t] <= i)
            t++;

        ans[i] = min (ans[i], (int)all.size () - t + 1);
    }
}

void goo (vector<int> &ans, const vector<int> &small, const vector<int> &big)
{
    int t = 0;

    for (int i = 0; i < ans.size (); i++)
    {
        while (t < small.size () && small[t] <= i)
            t++;

        ans[i] = min (ans[i], (int)big.size () + (int)small.size () - t);
    }
}

void solve (istream &cin, ostream &cout)
{
    int n;

    cin >> n;

    vector<int> arr (n), cnt ((int)1e6 + 1);

    for (auto &it : arr)
    {
        cin >> it;
        cnt[it]++;
    }

    sort (arr.begin (), arr.end ());

    unordered_set<int> used (arr.begin (), arr.end ());
    unordered_set<int> div;

    for (auto it : used)
        for (int i = 2 * it; i < 1e6 + 10; i += it)
            if (used.count (i))
                div.insert (it);

    vector<int> small, big;

    for (auto it : used)
        (div.count (it) ? small : big).push_back (cnt[it]);

    auto all = small;
    all.insert (all.end (), big.begin (), big.end ());

    sort (small.begin (), small.end ());
    sort (big.begin (), big.end ());
    sort (all.begin (), all.end ());

    vector<int> prall (all.size () + 1);

    for (int i = 1; i < prall.size (); i++)
        prall[i] = prall[i - 1] + all[i - 1];

    vector<int> prsmall (small.size () + 1);

    for (int i = 1; i < prsmall.size (); i++)
        prsmall[i] = prsmall[i - 1] + small[i - 1];

    vector<int> ans (n + 1, used.size ());

    foo (ans, prall);
    goo (ans, prsmall, big);

    for (auto it : ans)
        cout << it << ' ';
    cout << endl;
}

int main ()
{
    const string filename = "equal";

    ifstream fin (filename + ".in");

    if (fin.fail ())
        solve (cin, cout);
    else
    {
        ofstream fout (filename + ".out");

        solve (fin, fout);
    }

    return 0;
}
