#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <string>
#include <unordered_set>
#include <set>
#include <unordered_map>
#include <map>

#pragma comment(linker,"/STACK:200000000")

using namespace std;

const int inf = 1e9 + 7;

bool check (long long n, long long wh)
{
    if (wh < 2)
        return false;

    int cnta = 0;

    while (n % wh == 0)
    {
        n /= wh;
        cnta++;
    }
    wh++;

    while (n % wh == 0)
        n /= wh;

    return n == 1 && cnta > 0;
}

void solve (istream &cin, ostream &cout)
{
    long long n;

    cin >> n;

    unordered_set<long long> ans;
    ans.insert (n);

    if (n & (n - 1))
    {
        for (int num = 1; num < 100; num++)
        {
            long long wh = pow (n, 1.0 / num);

            for (auto i = wh - 2; i < wh + 3; i++)
                if (check (n, i))
                    ans.insert (i);
        }

        cout << ans.size () << endl;

        for (auto it : ans)
        {
            auto tmp = n;

            int cnta = 0, cntb = 0;

            while (tmp % it == 0)
            {
                tmp /= it;
                cnta++;
            }
            it++;

            while (tmp % it == 0)
            {
                tmp /= it;
                cntb++;
            }

            cout << cnta + cntb;

            for (int i = 0; i < cnta; i++)
                cout << ' ' << it - 1;

            for (int i = 0; i < cntb; i++)
                cout << ' ' << it;

            cout << endl;
        }
    }
    else
        cout << -1 << endl;
}

int main ()
{
    const string filename = "little";

    ifstream fin (filename + ".in");

    if (fin.fail ())
        solve (cin, cout);
    else
    {
        ofstream fout (filename + ".out");

        solve (fin, fout);
    }

    return 0;
}
