#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>

using namespace std;

vector < vector < int > > g, comp;
vector < int > us, pr, tin, up, col, forb;
int T, timer;

set < pair < int, int > > bad;
set < int > in;
vector < int > cy;

int fnd(int v, int p) {
	us[v] = timer;
	up[v] = tin[v] = T++;

	int cn = 0;

	int mn = tin[v];

	for (int u : g[v]) {
		if (u == p)
			continue;
		if (us[u] != timer) {
			fnd(u, v);
			cn++;
		}
		mn = min(mn, up[u]);
	}

	up[v] = mn;

	if (p != -1) {
		for (int u : g[v]) {
			if (u == p)
				continue;
			forb[v] |= up[u] >= tin[v];
		}
	}
	else {
		forb[v] = (cn != 1);
	}


	return up[v];
}

void split(int v) {
	us[v] = timer;

	for (int i : g[v]) {
		if (us[i] == timer || forb[i])
			continue;
		split(i);
	}

	comp[comp.size() - 1].push_back(v);
	col[v] = comp.size() - 1;
	return;
}

bool skip(int v, int c) {
	return !forb[v] && col[v] != c;
}

bool cycle(int v, int p, int c) {
	us[v] = timer;

	for (int u : g[v]) {
		if (u == p || skip(u, c))
			continue;
		if (us[u] == timer) {
			bad.insert({ v, u });
			bad.insert({ u, v });
			in.insert(v);
			cy.push_back(v);
			int k = v;
			while (k != u) {
				bad.insert({ pr[k], k });
				bad.insert({ k, pr[k] });
				k = pr[k];
				in.insert(k);
				cy.push_back(k);
			}
			return 1;
		}
		pr[u] = v;
		if (cycle(u, v, c))
			return 1;
	}
	return 0;
}

int nf(int v, int p, int c, int st) {
	us[v] = timer;

	for (int u : g[v]) {
		if (u == p || skip(u, c) || bad.find({ v, u }) != bad.end())
			continue;
		pr[u] = v;
		if (in.find(u) != in.end() && u != st)
			return u;
		if (u == st)
			continue;
		int x = nf(u, v, c, st);
		if (x != -1)
			return x;
	}
	return -1;
}

bool check(vector < int > cur) {
	bad.clear();
	in.clear();
	cy.clear();
	if (cur.size() == 1)
		return 0;

	int c;

	for (int i : cur) {
		if (!forb[i]) {
			c = col[i];
			cycle(i, -1, c);
			break;
		}
	}
	timer++;

	for (int v : in) {
		if (us[v] == timer)
			continue;
		int x = nf(v, -1, c, v);
		if (x != -1) {
			cout << x + 1 << ' ' << v + 1 << '\n';
			vector < int > w1{ x }, w2, w3;
			int t = x;
			while (t != v) {
				t = pr[t];
				w1.push_back(t);
			}
			cout << w1.size() << ' ';
			for (int i : w1)
				cout << i + 1 << ' ';
			cout << '\n';

			int p1 = find(cy.begin(), cy.end(), x) - cy.begin();
			int p2 = find(cy.begin(), cy.end(), v) - cy.begin();

			for (int i = p1; i != p2; i++, i %= cy.size())
				w2.push_back(cy[i]);
			w2.push_back(v);

			for (int i = p1; i != p2; i--, i = (i < 0 ? i + cy.size() : i))
				w3.push_back(cy[i]);
			w3.push_back(v);

			cout << w2.size() << ' ';
			for (int i : w2)
				cout << i + 1 << ' ';
			cout << '\n';
			cout << w3.size() << ' ';
			for (int i : w3)
				cout << i + 1 << ' ';
			cout << '\n';

			timer++;
			return 1;
		}
	}

	timer++;
	return 0;
}

void solve() {
	T = 0;
	timer = 1;
	g.clear();
	us.clear();
	pr.clear();
	tin.clear();
	up.clear();
	col.clear();
	comp.clear();
	forb.clear();

	int n, m;
	cin >> n >> m;
	
	g.resize(n);
	us.resize(n, 0);
	tin.resize(n);
	up.resize(n, 0);
	pr.resize(n, -1);
	col.resize(n);
	forb.resize(n);

	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		x--, y--;
		g[x].push_back(y);
		g[y].push_back(x);
	}

	for (int i = 0; i < n; i++) {
		if (us[i] == timer)
			continue;
		fnd(i, -1);
	}

	timer++;

	for (int i = 0; i < n; i++) {
		if (forb[i] || us[i] == timer)
			continue;
		comp.emplace_back();
		split(i);
	}
	timer++;

	for (auto &c : comp) {
		if (check(c))
			return;
	}
	cout << "-1\n";
	return;
}

const long long INF = 1e18 + 100;
int main() {
	ios_base::sync_with_stdio(false);
	freopen("grand.in", "r", stdin);
	freopen("grand.out", "w", stdout);
	
	int test;
	cin >> test;
	while (test--) {
		solve();
	}

	return 0;
}