#include <fstream>
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

void paintline(vector<vector<char>> &grid, int row = -1, int col = -1) {
	for (int i = 0; i < grid.size(); i++)
		for (int j = 0; j < grid[0].size(); j++)
			if (col != -1) {
				 grid[i][col] = '#';
			} else if (row != -1) {
				 grid[row][j] = '#';
			}
}

void taskB()
{
	ifstream in("boolean.in");
	ofstream out("boolean.out");

	string testcase;
	string unique;
	std::vector<int8_t> final;
	in >> testcase;

	if (testcase.size() == 1) {
		out << 1;
		return;
	}

	if (testcase.size() == 2 && testcase[0] == '~') {
		out << 1;
		return;
	}
	
	int n_odds = 0;
	bool inv = false;
	for (int8_t c : testcase) {
		if(c != '|') {
			if (c == '~') {
				inv = true;
				continue;
			}

			if (unique.find(c) == string::npos) {
				unique += c;
			}
			
			if (inv)
				c = -c;

			if ( find(final.begin(), final.end(), c) == final.end() ) {
				final.push_back(c);
				if(c < 0 && inv) n_odds++;
			}

			if (inv) {
				//c = -c;
				inv = false;
			}
			
		}
	}
	//out << n_odds<< endl;
//	out << unique.size() << endl;
	//out << final.size() << endl;
	
	int res = pow(2, unique.size());
	if (n_odds % 2 == 0)
		res--;
	out << res;
}

void taskK() {
	ifstream in("kotlin.in");
	ofstream out("kotlin.out");

	int h, w, n, k, b = 0;
	in >> h >> w >> n;
	vector< vector<char> > grid(h);
	for (auto& vec : grid) {
		vec = vector<char>(w, '.');
	}

	int cutW = 0;
	if (w % 2 != 0) {
		cutW = (w - 1) / 2;
	}
	else {
		cutW = (w - 2) / 2;
	}

	int cutH = 0;
	if (h % 2 != 0) {
		cutH = (h - 1) / 2;
	}
	else {
		cutH = (h - 2) / 2;
	}

	if ((cutW + 1)*(cutH + 1) < n) {
		out << "Impossible";
		return;
	}

	if (n % 2 != 0) {
		if (cutH >= n - 1) {
			// cut by width
			for (int i = 1; i < h; i += 2) {
				paintline(grid, i, -1);
			}
		}
		if (cutW >= n - 1) {
			// cut by height
			for (int i = 1; i < w; i += 2) {
				paintline(grid, -1, i);
			}
		}
	}
	else {
		k = n/2;
		for (int i = 1; i < h; i += 2) {
			// cut by width
			if (cutH >= k - 1 && k > 1) {
				paintline(grid, i, -1);
				k--;
			}
		}
		for (int i = 1; i < w; i += 2) {
			// cut by height
			if (cutW >= k - 1 && k > 0) {
				paintline(grid, -1, i);
				k--;
			}
		}
	}

	for (auto const& vec : grid) {
		for (auto const& ch : vec)
			out << ch;
		out << endl;
	}
}

void taskL() {
	int h, i = 1, g = 0, m = 0, n;
	vector< vector<long long> > vec;

	ifstream in("little.in");
	ofstream out("little.out");

	in >> n;

	while (n / i >= i) {
		if (n % i == 0) {
			if (i == n / i - 1 || i == n / i || i == n / i + 1) {
				vec.push_back(vector <long long> ());
				vec[m].push_back(g + 1);
				vec[m].push_back(n / i);
				for (int i = 0; i < g && i != 1; i++) {
					vec[m].push_back(i);
				}
				m++;
			}
			g++;
		}
		else
			g = 0;
		i++;
	}

	out << m << "\n";
	for (auto const& v : vec) {
		for (auto const& ch : v)
			out << ch;
		out << endl;
	}
}

int main()
{
	taskB();
	//taskL();
	return 0;
}
