#include <vector>
#include <algorithm>
#include <set>
#include <iostream>
#include <string>



#define pb push_back
using namespace std;

typedef pair< int, int > pii;
typedef long long ll;

#define vec vector
#define ALL(x) (x).begin(), (x).end()

int const inf = 1e9;
ll const inf64 = 1e18;

vector<int> p;
vector<bool> f;
vector<vector<int>> c;

int solve(int v) {
	if (c[v].empty()) {
		f[v] = true;
		return 0;
	}

	int ans = 0;
	for (int i : c[v])
		ans += solve(i);

	int freec = -1;
	for (int i : c[v])
		if (f[i])
			freec = i;

	if (freec == -1) {
		f[v] = true;
		return ans;
	}

	f[freec] = false;
	f[v] = false;
	return ans + 1;
}

int getfc(int v, vector<int> &fvec, bool take=true) {
	int ans = 0;
	if (take && f[v]) {
		ans = f[v];
		fvec.push_back(v);
	}
	for (int i : c[v])
		ans += getfc(i, fvec);
	return ans;
}

int main() {
	freopen("hidden.in", "r", stdin);
	freopen("hidden.out", "w", stdout);
	int n;
	cin >> n;

	p.resize(n);
	p[0] = -1;
	c.resize(n);
	f.resize(n);

	for (int i = 1; i < n; i++) {
		int j;
		cin >> j, --j;
		p[i] = j;
		if (j != -1)
			c[j].push_back(i);
	}

	vector<int> roots;
	for (int i = 0; i < n; i++)
		if (p[i] == -1)
			roots.push_back(i);

	int ans = 0;
	for (int i = 0; i < roots.size(); i++) {
		int r = roots[i];
		ans += solve(r);
	}

	vector<int> free_r, busy_r;
	for (int i : roots) {
		if (i != 0) {
			if (f[i])
				free_r.push_back(i);
			else busy_r.push_back(i);
		}
	}

	vector<pair<int, int>> order(free_r.size());
	vector<vector<int>> fc_list(free_r.size());
	for (int i = 0; i < free_r.size(); i++) {
		int fc = getfc(free_r[i], fc_list[i], false);
		order[i] = { fc, free_r[i] };
	}

	sort(order.begin(), order.end());
	reverse(order.begin(), order.end());

	vector<int> got;
	for (int i : busy_r)
		p[i] = 0;
	getfc(0, got);

	for (auto& i : order) {
		int v = i.second;
		if (got.empty())
			getfc(v, got);
		else {
			p[v] = got.back();
			got.pop_back();
			getfc(v, got, false);
			ans++;
		}
	}

	cout << ans << '\n';
	for (int i = 1; i < p.size(); i++)
		cout << p[i] + 1 << ' ';
	cout << endl;

}