#include <bits/stdc++.h>

using namespace std;

typedef pair< int, int > pii;
typedef long long ll;

#define vec vector
#define ALL(x) (x).begin(), (x).end()

int const inf = 1e9;
ll const inf64 = 1e18;

int const N = 5e4 + 5;

inline __int128 get128(ll n_i, ll P, ll p_i, ll absN) { // (a, b, c, d) -> ab + cd
    return (__int128)n_i * (__int128)P + (__int128)p_i * (__int128)absN;
}

inline int leq(ll a, ll b, ll c, ll d) {
    return (__int128)a * (__int128)b <= (__int128)c * (__int128)d;
}

int n, m;
int a[N];
ll pref_plus[N];
ll pref_minus[N];
ll total_plus = 0;
ll total_minus = 0;
int k;
int result = -1;

void readInput() {
    scanf("%d %d", &n, &m);
    for(int i = 1;i <= n;i++) {
        scanf("%d", &a[i]);
    }
}

struct Line {
    ll k, b;
    int id;

    Line() {
        k = b = 0;
        id = -1;
    }

    Line(ll _k, ll _b, int _id) {
        k = _k;
        b = _b;
        id = _id;
    }
};

inline bool check(Line const & L1, Line const & L2, Line const & L3) {
    return leq(L1.b - L3.b, L2.k - L1.k, L1.b - L2.b, L3.k - L1.k);
}

inline bool is_x_left_to_intersect(Line const & L1, Line const & L2, ll u, ll v) {
    return get128(L1.b - L2.b, v, L1.k - L2.k, u) > 0;
}

vec< Line > st[N];

void add_line(int block, Line L) {
    Line L3 = L, L1, L2;

    while((int)st[block].size() > 1) {
        L1 = st[block][(int)st[block].size() - 2];
        L2 = st[block][(int)st[block].size() - 1];

        if(check(L1, L2, L3)) {
            st[block].pop_back();
        }else {
            break;
        }
    }

    st[block].push_back(L);
}

inline Line getLine(int pos) {
    return Line(pref_plus[pos], pref_minus[pos], pos);
}

inline int get_max(int i, int j, ll u, ll v) {
    Line L1 = getLine(i);
    Line L2 = getLine(j);
    __int128 x = get128(L1.k, u, L1.b, v);
    __int128 y = get128(L2.k, u, L2.b, v);
    if(x > y) {
        return i;
    }else if(x < y) {
        return j;
    }else {
        return i < j ? i : j;
    }
}

void get_best(int block, ll u, ll v) {
    result = -1;
    /*for(Line tmp_line : st[block]) {
        if(result == -1) {
            result = tmp_line.id;
        }else {
            result = get_max(result, tmp_line.id, u, v);
        }
    }*/
    result = get_max(st[block].front().id, st[block].back().id, u, v);

    if((int)st[block].size() <= 2) {
        return;
    }

    int bl = 0;
    int br = (int)st[block].size() - 1;
    int bm;

    while(br - bl > 1) {
        bm = (bl + br) / 2;

        if(is_x_left_to_intersect(st[block][bm], st[block][bm + 1], u, v)) {
            br = bm;
        }else {
            bl = bm + 1;
        }
    }

    result = get_max(result, st[block][bl].id, u, v);
    if(bl < br) {
        result = get_max(result, st[block][br].id, u, v);
    }
}

void build() {
    for(int i = 1;i <= n;i++) {
        if(i % k) {
            pref_plus[i] = pref_plus[i - 1];
            pref_minus[i] = pref_minus[i - 1];
        }

        if(a[i] > 0) {
            pref_plus[i] += a[i];
            total_plus += a[i];
        }else {
            pref_minus[i] += a[i];
            total_minus += a[i];
        }
    }

    for(int i = 1;i <= n;i++) {
        if(result == -1) {
            result = i;
        }else {
            __int128 cur_res = get128(
                pref_minus[result],
                total_plus,
                pref_plus[result],
                -total_minus
            );

            __int128 tmp_res = get128(
                pref_minus[i],
                total_plus,
                pref_plus[i],
                -total_minus
            );

            if(tmp_res > cur_res) {
                result = i;
            }
        }
    }

    for(int i = 1;i <= n;i++) {
        add_line(i / k, Line(pref_plus[i], pref_minus[i], i));
    }

    /*for(int i = 0;i * k <= n;i++) {
        cout << i << " : ";
        for(Line l : st[i]) {
            cout << l.id << " ";
        }
        cout << "\n";
    }*/
}

void rebuild(int block) {
    int l = block * k;
    int r = l + k - 1;
    l = max(l, 1);
    r = min(r, n);

    /*cout << "rebuild [" << l << " .. " << r << "]\n";

    cout << "a = ";
    for(int i = 1;i <= n;i++) {
        cout << a[i] << " ";
    }
    cout << "\n";*/

    st[block].clear();

    for(int i = l;i <= r;i++) {
        if(i > l) {
            pref_plus[i] = pref_plus[i - 1];
            pref_minus[i] = pref_minus[i - 1];
        }else {
            pref_plus[i] = 0;
            pref_minus[i] = 0;
        }

        if(a[i] > 0) {
            pref_plus[i] += a[i];
        }else {
            pref_minus[i] += a[i];
        }

        //cout << a[i] << " ? " << pref_plus[i] << " - " << pref_minus[i] << "\n";

        add_line(block, Line(pref_plus[i], pref_minus[i], i));
    }
}

void update_result() {
    for(int i = 0;i * k <= n;i++) {
        get_best(i, -total_minus, total_plus);
    }
    /*for(int i = 0;i * k <= n;i++) {
        cout << i << " : ";
        for(Line l : st[i]) {
            cout << l.k << " " << l.b << " " << l.id << "; ";
        }
        cout << "\n";
    }*/
}

int main() {

#ifdef debug
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    freopen("joker.in", "r", stdin);
    freopen("joker.out", "w", stdout);
#endif // debug

    readInput();

    k = sqrt((double)n * (log(n) / log(2))) + 4;

    build();

    printf("%d\n", result);

    for(int pos, value, iter = 0;iter < m;iter++) {
        scanf("%d %d", &pos, &value);

        if(a[pos] > 0) {
            total_plus -= a[pos];
        }else {
            total_minus -= a[pos];
        }

        a[pos] = value;

        if(a[pos] > 0) {
            total_plus += a[pos];
        }else {
            total_minus += a[pos];
        }

        //cout << "#" << iter << "\n";

        rebuild(pos / k);
        update_result();

        printf("%d\n", result);
    }

    return 0;
}
