#include <bits/stdc++.h>

#define ll long long
#define FILENAME "little"
#define fori for (int i = 0; i < int(n); ++i)
#define forj for (int j = 0; j < int(n); ++j)
#define fori1 for (int i = 1; i < int(n); ++i)
#define forj1 for (int j = 1; j < int(n); ++j)

using namespace std;

ll mul(ll a, ll b, ll mod) {
    ll c = 0;
    for(; b > 0; b /= 2) {
        if (b % 2 == 1) {
           c = (c + a) % mod;
        }
        a = (a + a) % mod;
    }
    return c;
}

ll pow(ll a, ll b, ll mod) {
    ll c = 1;
    for(; b > 0; b /= 2) {
        if (b % 2 == 1) {
           c = mul(c, a, mod);
        }
        a = mul(a, a, mod);
    }
    return c;
}


bool isPrime(ll n) {
    if (n < 2) {
       return false;
    }

    if (n == 2 || n == 3) {
        return true;
    }

    if (n % 2 == 0 || n % 3 == 0) {
        return false;
    }

    ll m = n - 1;
    ll s = (n - 1) / 2;
    bool p = false;
    for (int i = 0; i < 20; i++) {
        ll a = (rand() + 3) % n;
        if (a < 2) {
            continue;
        }

        ll b = pow(a, s, n);


        if (b == 1) {
           continue;
        }

        if (b == m) {
            p = true;
            continue;
        }

        return false;
    }

    return p;
}

ll gcd(ll a, ll b) {
    if (b == 0){
        return a;
    } else {
        return gcd(b, a%b);
    }
}

ll f(ll x, ll mod) {
    x = mul(x, x, mod);
    x = (x + 1) % mod;
    return x;
}

void fact(ll n, set<ll>& d) {


    if (n == 1) {
        return;
    }

    if (isPrime(n)) {
        d.insert(n);
        return;
    }

    ll x = 1, y = 1;

    ll g = 1;

    while(g == 1 || g == n) {
        //cout << x <<  ' ' << y <<  ' ' << n << '\n';
        x = f(x, n);
        y = f(f(y, n), n);
        g = gcd(abs(x - y), n);
    }

    fact(g, d);

    while(n % g == 0) {
        n /= g;
    }

    fact(n, d);
}

void getdivs(ll n, vector<ll>& d) {
    set<ll> s;
    ll m = n;
    for (ll p = 2; p < 1000000; p++) {
        while(n % p == 0){
            n /= p;
            s.insert(p);
        }
    }

    fact(n, s);


    int len = 0;
    vector<ll>  p;
    vector<int> a;
    vector<int> e;
    for (ll v : s) {
        int cur = 0;
        while (m % v == 0) {
            ++cur;
            m /= v;
        }

        p.push_back(v);
        a.push_back(cur);
        e.push_back(0);
        ++len;
    }

    while(true){
        ll cur = 1;

        for (int i = 0; i < len; i++) {
            for(int j = 0; j < e[i]; j++) {
                cur *= p[i];
            }
        }

        d.push_back(cur);

        bool b = true;

        for (int i = 0; b && i < len; i++) {
            ++e[i];

            if (e[i] > a[i]) {
                e[i] = 0;
            } else {
                b = false;
            }
        }

        if(b){
            break;
        }
    }
}

bool isPP(ll n) {
    while(n % 2 == 0) {
        n /= 2;
    }

    return n == 1;
}

bool solve(ll n, ll d, vector<ll>& ans) {
    if(d == 1) {
        return false;
    }
    while(n % d == 0) {
        ans.push_back(d);
        n /= d;
    }

    if(n == 1) {
        return true;
    }

    ++d;
    while(n % d == 0) {
        ans.push_back(d);
        n /= d;
    }

    return n == 1;
}

int main()
{
    ios_base::sync_with_stdio(false);
    freopen(FILENAME".in", "r", stdin);
    freopen(FILENAME".out", "w", stdout);
    ll n;
    cin >> n;


    vector<vector<ll>> ans;

    if (isPP(n)) {
        cout << -1 << '\n';
    } else {
        ll num = n;
        vector<ll> d;
        getdivs(n, d);
        vector<ll> tmp;
        for(ll x : d){
            if(solve(n , x, tmp)) {
                ans.push_back(tmp);
            }
            tmp.clear();
        }

        cout << ans.size() << '\n';

        for (vector<ll>& tmp : ans) {
            cout << tmp.size();

            for (ll x : tmp) {
                cout << ' ' << x;
            }
            cout << '\n';
        }

    }
}
