#include <iostream>
#include <cmath>
#include <set>
#include <vector>
#include <algorithm>

#define mp make_pair

using namespace std;

typedef long long li;

double E = exp(1);

double ln(double x)
{
	return log(x) / log(E);
}

double log2(double x)
{
	return log2(x) / log2(2);
}

li bin_pow(li a, li n)
{
	if (n == 0)
		return 1ll;
	return (n % 2) ? a * bin_pow(a, n - 1) : bin_pow(a * a, n / 2);
}

li f(li n, li m)
{
	li x = trunc(exp(log(n) / m));
	for (li i = max(1ll, x - 2000); i <= x + 2000; ++i)
		if (bin_pow(i, m) <= n && bin_pow(i + 1, m) > n)
			return i;
}

pair<int, li> divs(li n, li x)
{
	int k = 0;
	li degx = 1;
	while (n % x == 0 || n == 0)
	{
		n /= x;
		k++;
		degx *= x;
	}
	return mp(k, degx);
}

int main()
{
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else
	freopen("little.in", "r", stdin);
	freopen("little.out", "w", stdout);
#endif
	li n;
	cin >> n;
	li nn = n;

	int k = 0;
	while (nn > 1)
	{
		nn /= 2;
		k++;
	}
	li deg2 = 1;
	for (int i = 0; i < k; ++i)
	{
		deg2 *= 2;
	}
	if (deg2 == n)
	{
		cout << "-1\n";
		return 0;
	}

	set<vector<li>> ans;
	for (int i = 1; i < k + 3; ++i)
	{
		li x = trunc(f(n, i));
		if (x == 1)
			continue;
		auto q = divs(n, x), p = divs(n, (x + 1));
		if (q.first == 0)
			continue;
		if (n == q.second * p.second)
		{
			vector<li> v;
			v.push_back(p.first + q.first);
			for (int j = 0; j < q.first; ++j)
				v.push_back(x);
			for (int j = 0; j < p.first; ++j)
				v.push_back(x + 1);
			ans.insert(v);
		}
	}

	cout << ans.size() << "\n";
	for (auto i : ans)
	{
		for (auto j : i)
			cout << j << ' ';
		cout << "\n";
	}

	return 0;
}