#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <memory.h>
#include <string>
#include <cstring>
#include <cassert>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; --i)
#define mp(x, y) make_pair(x, y)
#define pb push_back
#define sz(c) int((c).size())
#define all(c) (c).begin(), (c).end()
#define fst first
#define snd second

#ifdef LOCAL
#define eprintf(args...) fprintf(stderr, args)
#else
#define eprintf(args...) ;
#endif

#define FILE_NAME "boolean"

using ll = long long;
using vi = vector<int>;
using vvi = vector<vi>;
using pii = pair<int, int>;


const vi segs = {6, 2, 5, 5, 4, 5, 6, 3, 7, 6};

string s;

bool read() {
    if  (!(cin >> s)) {
        return 0;
    }
    return 1;
}

void solve ()
{
    const int symb = 256;
    vi cnt(symb);
                     
    assert(!s.empty());
    int neg = 0;
    for (char ch : s)
    {
        if (ch == '|')
            neg = 0;
        else if (ch == '~')
            neg = 1;
        else
        {
            cnt[ch] |= (1 << neg);
        }
    }
                     
    int total = count_if(all(cnt), [&] (int x) {return x > 0;});
    assert(total <= 2 * 26);
    if (count(all(cnt), 3))
        cout << (1LL << total) << endl;
    else
        cout << (1LL << total) - 1 << endl;
}                      

int main() {
#ifdef LOCAL
    freopen(FILE_NAME ".in", "r", stdin);
    freopen(FILE_NAME ".out", "w", stdout);
#else
    freopen(FILE_NAME ".in", "r", stdin);
    freopen(FILE_NAME ".out", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    while (read()) {
        solve();
    }

    return 0;
}





