#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <memory.h>
#include <string>
#include <cstring>
#include <cassert>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; --i)
#define mp(x, y) make_pair(x, y)
#define pb push_back
#define sz(c) int((c).size())
#define all(c) (c).begin(), (c).end()
#define fst first
#define snd second

#ifdef LOCAL
#define eprintf(args...) fprintf(stderr, args)
#else
#define eprintf(args...) ;
#endif

#define FILE_NAME "consonant"

using ll = long long;
using vi = vector<int>;
using vvi = vector<vi>;
using pii = pair<int, int>;

const int MAXN = 1e6 + 10;
const int A = 26;
const string vowels = "aeiouwy";

bool is_vowel(char c) {
    for (const auto& ch : vowels) {
        if  (c == ch) {
            return 1;
        }
    }
    return 0;
}

int mem_code[A];

int code(char c) {
    if  (mem_code[c - 'a'] != -1) {
        return mem_code[c - 'a'];
    }
    int& res = mem_code[c - 'a'];
    if  (is_vowel(c)) {
        return (res = -2);
    }
    int ptr = 0;
    forn(i, A) {
        if  ('a' + i == c) {
            return (res = ptr);
        }
        if  (!is_vowel('a' + i)) {
            ++ptr;
        }
    }
    assert(0);
    return -1;
}

int n;
char s[MAXN];

bool read() {
    scanf("%s\n", s);
    n = int(strlen(s));
    return 1;
}

bool bit(int mask, int i) {
    return (mask >> i) & 1;
}

int cnt[A][A];

void solve() {
    memset (cnt, 0, sizeof cnt);
    forn(i, n - 1) {
        int c1 = code(s[i]);
        int c2 = code(s[i + 1]);
        if  (c1 >= 0 && c2 >= 0) {
            ++cnt[c1][c2];
            ++cnt[c2][c1];
        }
    }

    const int B = A - sz(vowels);
    int best_mask = 0;
    int ans = -1;
    forn(mask, 1 << B) {
        int cur = 0;
        forn(c1, B) if  (bit(mask, c1)) {
            forn(c2, B) {
                if  (!bit(mask, c2)) {
                    cur += cnt[c1][c2];
                }
            }
        }

        if  (cur > ans) {
            ans = cur;
            best_mask = mask;
        }
    }

    forn(i, n) {
        int c = code(s[i]);
        if  (c >= 0 && bit(best_mask, c)) {
            s[i] = toupper(s[i]);    
        }
    }

    printf("%s\n", s);
}


int main() {
#ifdef LOCAL
    freopen(FILE_NAME ".in", "r", stdin);
//    freopen(FILE_NAME ".out", "w", stdout);
#else
    freopen(FILE_NAME ".in", "r", stdin);
    freopen(FILE_NAME ".out", "w", stdout);
#endif

    memset (mem_code, -1, sizeof mem_code);

    while (read()) {
        solve();

        break;
    }

    return 0;
}





