#include <iostream>
#include <cmath>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <memory.h>
#include <string>
#include <cstring>
#include <cassert>
#include <queue>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; --i)
#define mp(x, y) make_pair(x, y)
#define pb push_back
#define sz(c) int((c).size())
#define all(c) (c).begin(), (c).end()
#define fst first
#define snd second

#ifdef LOCAL
#define eprintf(args...) fprintf(stderr, args)
#else
#define eprintf(args...) ;
#endif

#define FILE_NAME "equal"

using ll = long long;
using vi = vector<int>;
using vvi = vector<vi>;
using pii = pair<int, int>;

const int MAX = 1e6 + 10;
const int MAXN = 3e5 + 10;

int n;
vi a;

bool read() {
    if  (scanf("%d", &n) < 1) {
        return 0;
    }
    a.resize(n);
    forn(i, n) {
        scanf("%d", &a[i]);
    }
    return 1;
}

int cnt[MAX];
int ans[MAXN];

void solve() {
    memset (cnt, 0, sizeof cnt);
    forn(i, n) {
        ++cnt[a[i]];
//        eprintf("i=%d, a=%d\n", i, a[i]);
    }
//    return;

    priority_queue<pii, vector<pii>> Q;
    for (int x = 1; x < MAX; ++x) {
        if (!cnt[x]) {
            continue;
        }
        bool was = 0;
        for (int y = 2 * x; y < MAX; y += x) {
            if  (cnt[y]) {
                was = 1;
                break;
            }
        }
        if  (was) {
            Q.push(mp(-cnt[x], x));
        }
    }


    forn(k, n + 1) {
        ans[k] = 0;
    }

//    return;

    for (int k = 1; k <= n; ++k) {
        ans[k] = ans[k - 1];
        if  (!Q.empty()) {
            const auto mn = Q.top();
            Q.pop();
            int x = mn.snd;
            assert(cnt[x] > 0);
            --cnt[x];
            if  (!cnt[x]) {
                ++ans[k];
            } else {
                Q.push(mp(-cnt[x], x));
            }
        } else {
            vi roots;
            for (int x = 1; x < MAX; ++x) {
                if  (cnt[x] > 0) {
                    roots.pb(cnt[x]);
                }
            }
            sort(all(roots));
        
            int ptr = 0;
            int sum = 0;
            for (int k2 = k; k2 <= n; ++k2) {
                ans[k2] = ans[k - 1];

                while  (ptr < sz(roots) && sum + roots[ptr] <= k2 - k  + 1) {
                    sum += roots[ptr];
                    ++ptr;
                }

                ans[k2] += max(0, ptr - 1);
            }

            break;
        }
    }

    set<int> S;
    forn(i, n) {
        S.insert(a[i]);
    }
    const int all = sz(S);
    forn(k, n + 1) {
        printf("%d ", max(1, all - ans[k]));
    }
    printf("\n");
}



int main() {
#ifdef LOCAL
    freopen(FILE_NAME ".in", "r", stdin);
//    freopen(FILE_NAME ".out", "w", stdout);
#else
    freopen(FILE_NAME ".in", "r", stdin);
    freopen(FILE_NAME ".out", "w", stdout);
#endif

    while (read()) {
        solve();

//        break;
    }

    return 0;
}





