#include <iostream>
#include <cmath>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <memory.h>
#include <string>
#include <cstring>
#include <cassert>
#include <queue>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; --i)
#define mp(x, y) make_pair(x, y)
#define pb push_back
#define sz(c) int((c).size())
#define all(c) (c).begin(), (c).end()
#define fst first
#define snd second

#ifdef LOCAL
#define eprintf(args...) fprintf(stderr, args)
#else
#define eprintf(args...) ;
#endif

#define FILE_NAME "equal"

using ll = long long;
using vi = vector<int>;
using vvi = vector<vi>;
using pii = pair<int, int>;

const int MAX = 1e6 + 10;
const int MAXN = 3e5 + 10;

int n;
vi a;

bool read() {
    if  (scanf("%d", &n) < 1) {
        return 0;
    }
    a.resize(n);
    forn(i, n) {
        scanf("%d", &a[i]);
    }
    return 1;
}

int cnt[MAX];
int ans[MAXN];

const int INF = 1e9;

const int DIV = 0;
const int ROOT = 1;

vi roots;
int ITER;

struct Item {
    int type;

    int x;
    int pos;

    int cmp_value() const {
        if  (type == DIV) {
            return cnt[x];
        }
        assert(type == ROOT);
        
        if  (sz(roots) <= 1) {
            return INF;
        }

        assert(pos >= 0 && pos < sz(roots));

        if  (ITER == 1 && pos == 0) {
            return -INF;    
        }

        if  (pos == 0) {
            return roots[0] + roots[1];
        } else {
            return roots[pos];
        }
    }

    int value() const {
        if  (type == DIV) {
            return cnt[x];
        }
        assert(type == ROOT);
        
        if  (sz(roots) <= 1) {
            return INF;
        }

        assert(pos >= 0 && pos < sz(roots));
        
        if  (pos == 0) {
            return roots[0] + roots[1];
        } else {
            return roots[pos];
        }
    }

    bool operator < (const Item& it) const {
        return cmp_value() > it.cmp_value();
    }
};

void solve() {
    memset (cnt, 0, sizeof cnt);

    /*
    {
        a.clear();
        for (int v = 1; v <= 4; ++v) {
            forn(it, 3) {
                a.pb(v);
            }
        }
        forn(it, 2) {
            a.pb(12 * 5);
        }
        forn(it, 2) {
            a.pb(12 * 13);
        }
        forn(it, 2) {
            a.pb(12 * 7);
        }
        forn(it, 2) {
            a.pb(12 * 11);
        }
        n = sz(a);
    }
    */

    forn(i, n) {
        ++cnt[a[i]];
    }

    memset (ans, 0, sizeof ans);

    forn(iter, 2) {

    ITER = iter;

    roots.clear();
    priority_queue<Item, vector<Item>> Q;
    for (int x = 1; x < MAX; ++x) {
        if (!cnt[x]) {
            continue;
        }
        bool was = 0;
        for (int y = 2 * x; y < MAX; y += x) {
            if  (cnt[y]) {
                was = 1;
                break;
            }
        }
        if  (was) {
            Item it;
            it.type = DIV;
            it.x = x;
            Q.push(it);
        } else {
            roots.pb(cnt[x]);
        }
    }

    sort(all(roots));
    if  (sz(roots) > 1) {
        Item it;
        it.type = ROOT;
        it.pos = 0;
        Q.push(it);
    }

    {
        int pref_ans = 0;
        int k = 1;
        while (k <= n) {
            if  (Q.empty()) {
                ans[k] = INF;
                ++k;
                continue;
            }

            const auto mn = Q.top();
            Q.pop();

            int val = mn.value();
            int last_k = k + val - 1;

//            eprintf("val=%d, k=%d, last_k=%d\n", val, k, last_k);

            for (int kk = k; kk <= n && kk < last_k; ++kk) {
                ans[kk] = max(ans[kk], pref_ans);        
            }

            if  (last_k > n) {
                break;
            }

            ++pref_ans;
            ans[last_k] = max(ans[last_k], pref_ans);
            if  (mn.type == ROOT) {
                if (mn.pos == 0) {
                    if (2 < sz(roots)) {
                        Item it;
                        it.type = ROOT;
                        it.pos = 2;
                        Q.push(it);
                    }
                } else if  (mn.pos + 1 < sz(roots)) {
                    Item it;
                    it.type = ROOT;
                    it.pos = mn.pos + 1;
                    Q.push(it);
                }
            }
            k = last_k + 1;
        }
    }
    
    }

    set<int> S;
    forn(i, n) {
        S.insert(a[i]);
    }
    const int all = sz(S);
    forn(k, n + 1) {
        printf("%d ", max(1, all - ans[k]));
    }
    printf("\n");
}



int main() {
#ifdef LOCAL
    freopen(FILE_NAME ".in", "r", stdin);
//    freopen(FILE_NAME ".out", "w", stdout);
#else
    freopen(FILE_NAME ".in", "r", stdin);
    freopen(FILE_NAME ".out", "w", stdout);
#endif

    while (read()) {
        solve();

//        break;
    }

    return 0;
}





