#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <memory.h>
#include <string>
#include <cstring>
#include <cassert>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; --i)
#define mp(x, y) make_pair(x, y)
#define pb push_back
#define sz(c) int((c).size())
#define all(c) (c).begin(), (c).end()
#define fst first
#define snd second

#ifdef LOCAL
#define eprintf(args...) fprintf(stderr, args)
#else
#define eprintf(args...) ;
#endif

#define FILE_NAME "fygon20"

using ll = long long;
using vi = vector<int>;
using vvi = vector<vi>;
using pii = pair<int, int>;
using vll = vector<ll>;

                       
int n;
vector<string> lines;

bool read() {
    if  (!(cin >> n)) {
        return 0;
    }
    
    string s;
    getline(cin, s);
    lines.resize(n);
    forn (i, n) 
    {
        getline(cin, s);    
        lines[i] = s;
        cerr << s << endl;
    }
    return 1;
}

bool isvar (char ch)
{
    return 'a' <= ch && ch <= 'z' && ch != 'n';
}
bool isgood (char ch)
{
    return ('a' <= ch && ch <= 'z') || (ch == '1');
}

int read_until (const string &s, const string &what)
{
    forn (i, sz(s) - sz(what) + 1) 
    if (equal(s.begin() + i, s.begin() + i + sz(what), what.begin()))
        return i + sz(what);

    assert(false);
    return -1;
}

ll cnt_topsorts (vi masks)
{
    const int n = sz(masks);
    vll dp(1 << n);
    dp[0] = 1;

    forn (mask, (1 << n)) 
    {
        int rem = (((1 << n) - 1) ^ mask);
        forn (to, n) if ((rem >> to) & 1)
        {
            int others = (rem ^ (1 << to));
            if ((masks[to] & others) == 0)
                dp[mask ^ (1 << to)] += dp[mask];
        }
    }

    return dp[(1 << n) - 1];
}

void solve ()
{
    map<char, int> num;
    vi masks;

    forn (i, n - 1)
    {
        const string &s = lines[i];

        int pos = read_until(s, "for ");
        char cur = s[pos];
        assert(isvar(cur) && !num.count(cur));
        
        int h = sz(num);
        num[cur] = h;
        masks.pb(0);
        
        pos = read_until(s, "in range(");
        char from = s[pos];
        assert(isgood(from));
        
        pos = read_until(s, ", ");
        char to = s[pos]; 
        assert(isgood(to));
        if (isvar(from))
        {        
            auto it = num.find(from);
            assert(it != num.end());
            masks[it -> snd] |= (1 << h);
        }
        if (isvar(to))
        {
            auto it = num.find(to);
            assert(it != num.end());
            masks[h] |= (1 << (it -> snd));
        }
    }                  
               
    n--;
    assert(sz(masks) == n);

    if (n == 0)
    {
        cout << "0 1/1" << endl;
        return;
    }

    forn (i, n)
        masks[i] |= (1 << i);

    forn (k, n) forn (i, n) forn (j, n) 
    if ((masks[i] >> k) & 1)
    if ((masks[k] >> j) & 1)
        masks[i] |= (1 << j);

    vi cmp(n, -1);
    int ch = 0;    
    forn (i, n) 
    {       
        forn (j, i) if (masks[i] == masks[j])
        {
            cmp[i] = cmp[j];
            break;        
        }

        if (cmp[i] == -1)
            cmp[i] = ch++;
    }

    vi compr(*max_element(all(cmp)) + 1);
    forn (i, n) forn (j, n) if ((masks[i] >> j) & 1)
    if (cmp[i] != cmp[j])
        compr[cmp[i]] |= (1 << cmp[j]);
                                  
    {                            
        ll p = cnt_topsorts(compr);
        ll q = 1;
        forn (i, sz(compr))
            q *= i + 1;


        ll g = __gcd(p, q);
        p /= g, q /= g;

               cout << sz(compr) << ' ' << p << "/" << q << endl;
    }
}                      

int main() {
#ifdef LOCAL
    freopen(FILE_NAME ".in", "r", stdin);
    freopen(FILE_NAME ".out", "w", stdout);
#else
    freopen(FILE_NAME ".in", "r", stdin);
    freopen(FILE_NAME ".out", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    while (read()) {
        solve();
    }

    return 0;
}





