#include <iostream>
#include <cmath>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <memory.h>
#include <string>
#include <cstring>
#include <cassert>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; --i)
#define mp(x, y) make_pair(x, y)
#define pb push_back
#define sz(c) int((c).size())
#define all(c) (c).begin(), (c).end()
#define fst first
#define snd second

#ifdef LOCAL
#define eprintf(args...) fprintf(stderr, args)
#else
#define eprintf(args...) ;
#endif

#define FILE_NAME "hidden"

using ll = long long;
using vi = vector<int>;
using vvi = vector<vi>;
using pii = pair<int, int>;

const int MAXN = 100500;

int n;
int p[MAXN];
vi g[MAXN];
vi roots;
vector<set<int>> inc;
int dp[MAXN][2], paired[MAXN];

bool read() {
    if (scanf("%d", &n) < 1) {
        return 0;
    }
    p[0] = -1;
    for (int i = 1; i < n; i++) {
        scanf("%d", &p[i]);
        p[i]--;
    }
    return 1;
}

void calc_dp(int v) {
    dp[v][0] = dp[v][1] = 0;

    int sum_1 = 0;
    forn(i, sz(g[v])) {
        int w = g[v][i];

        //cout << "EDGE " << v << " -> " << w << endl;

        calc_dp(w);
        sum_1 += max(dp[w][0], dp[w][1]);
    }

    // fill dp[v][0]
    forn(i, sz(g[v])) {
        int w = g[v][i];
        dp[v][0] += max(dp[w][0], dp[w][1]);
    }

    // fill dp[v][1]
    dp[v][1] = dp[v][0];
    paired[v] = -1;
    forn(i, sz(g[v])) {
        int w = g[v][i];
        int ndp = sum_1 - dp[w][1] + dp[w][0] + 1;
        if (dp[v][1] < ndp) {
            dp[v][1] = ndp;
            paired[v] = w;
        }
    }
}

void fill_inc(int id, int v, int can_take) {
    //cout << "RUN " << v << ' ' << can_take << '\n';
    if (can_take && dp[v][0] >= dp[v][1]) {
        //cout << "don't take " << v << '\n';
        inc[id].insert(v);
        can_take = 0;
    }

    if (!can_take) {
        //inc[id].insert(v);
        // don't take v
        for (auto w: g[v]) {
            fill_inc(id, w, 1);
        }
    } else {
        //assert(paired[v] != -1);
        for (auto w: g[v]) {
            fill_inc(id, w, (paired[v] != w));
        }
    }
}
 
void solve() {
    forn(i, n) {
        g[i].clear();
    }
    roots.clear();
    forn(i, n) {
        if (p[i] == -1) {
            roots.pb(i);
        } else {
            g[p[i]].pb(i);
        }
    }

    inc.clear();
    inc.resize(sz(roots));

    forn(i, sz(roots)) {
        calc_dp(roots[i]);
    }

    forn(i, sz(roots)) {
        fill_inc(i, roots[i], 1);
    }

    forn(i, sz(roots)) {
        //cout << "ROOT " << roots[i] << ": " << dp[roots[i]][0] << ' ' << dp[roots[i]][1] << '\n';
        //cout << "incs: " << sz(inc[i]) << '\n';
    }

    set<pii> possible;

    for (int i = 1; i < sz(roots); i++) {
        // classify
        if (inc[i].empty()) {
            p[roots[i]] = 0;
        } else {
            if (dp[roots[i]][0] == dp[roots[i]][1]) {
                possible.insert(mp(-sz(inc[i]), i));
            } else {
                p[roots[i]] = 0;
                for (auto v: inc[i]) {
                    inc[0].insert(v);
                }
                inc[i].clear();
            }
        }
    }

    int cur_ans = 0;
    for (auto v: roots) {
        cur_ans += max(dp[v][0], dp[v][1]);
    }

    while (!possible.empty()) {
    /*
        cout << "INC 0: ";
        for (auto v: inc[0]) {
            cout << v << ' ';
        }
        cout << '\n';
    */    
        auto vp = *possible.begin();
        possible.erase(vp);

        int i = vp.snd;
        int v = roots[i];

        if (!inc[0].empty()) {
            int r = *inc[0].begin();
            inc[0].erase(r);
            inc[i].erase(v);

            cur_ans++;

            p[v] = r;
        } else {
            p[v] = 0;
        }

        //cout << "LINK " <<  v << " TO " << p[v] << endl;

        for (auto v: inc[i]) {
            inc[0].insert(v);
        }
        inc[i].clear();
    }

    cout << cur_ans << '\n';
    for (int i = 1; i < n; i++) {
        printf("%d ", p[i] + 1);
    }
    cout << '\n';
}


int main() {
#ifdef LOCAL
    freopen(FILE_NAME ".in", "r", stdin);
//    freopen(FILE_NAME ".out", "w", stdout);
#else
    freopen(FILE_NAME ".in", "r", stdin);
    freopen(FILE_NAME ".out", "w", stdout);
#endif

    while (read()) {
        solve();
    }

    return 0;
}





