#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <memory.h>
#include <string>
#include <cstring>
#include <cassert>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; --i)
#define mp(x, y) make_pair(x, y)
#define pb push_back
#define sz(c) int((c).size())
#define all(c) (c).begin(), (c).end()
#define fst first
#define snd second

#ifdef LOCAL
#define eprintf(args...) fprintf(stderr, args)
#else
#define eprintf(args...) ;
#endif

#define FILE_NAME "kotlin"

using ll = long long;
using vi = vector<int>;
using vvi = vector<vi>;
using pii = pair<int, int>;

int n, m, s;

bool read() {
    if (scanf("%d%d%d", &n, &m, &s) < 3) {
        return 0;
    }
    return 1;
}

void gen(pii p) {
    int N = p.fst;
    int M = p.snd;

    vector<string> table(n);
    forn(i, n) {
        table[i] = "";
        forn(j, m) {
            table[i] += '.';
        }
    }

    //cerr << p.fst << ' ' << p.snd << endl;

    int ptr = 0;
    for (int i = 0; i < N; i++) {
        if (ptr + 1 < n)
        forn(j, m) {
            table[ptr + 1][j] = '#';
        }
        ptr += 2;
    }

    while (ptr < n) {
        forn(j, m) {
            table[ptr][j] = '#';
        }
        ptr++;
    }

    ptr = 0;
    for (int i = 0; i < M; i++) {
        if (ptr + 1 < m)
        forn(j, n) {
            table[j][ptr + 1] = '#';
        }
        ptr += 2;
    }

    while (ptr < m) {
        forn(j, n) {
            table[j][ptr] = '#';
        }
        ptr++;
    }

    forn(i, n) {
        cout << table[i] << '\n';
    }
}

vector<pair<int, pii>> sizes;

void solve() {
    // gen all
    sizes.clear();

    int maxn = (n + 1) / 2;
    int maxm = (m + 1) / 2;
    for (int i = 1; i <= maxn; i++) {
        for (int j = 1; j <= maxm; j++) {
            sizes.pb(mp(i * j, mp(i, j)));
        }
    }

    for (auto cur_s: sizes) {
        if (cur_s.fst == s) {
            gen(cur_s.snd);
            return;
        }
    }

    cout << "Impossible\n";
}


int main() {
#ifdef LOCAL
    freopen(FILE_NAME ".in", "r", stdin);
//    freopen(FILE_NAME ".out", "w", stdout);
#else
    freopen(FILE_NAME ".in", "r", stdin);
    freopen(FILE_NAME ".out", "w", stdout);
#endif

    while (read()) {
        solve();
    }

    return 0;
}





