#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <memory.h>
#include <string>
#include <cstring>
#include <cassert>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; --i)
#define mp(x, y) make_pair(x, y)
#define pb push_back
#define sz(c) int((c).size())
#define all(c) (c).begin(), (c).end()
#define fst first
#define snd second

#ifdef LOCAL
#define eprintf(args...) fprintf(stderr, args)
#else
#define eprintf(args...) ;
#endif

#define FILE_NAME "little"

using ll = long long;
using vi = vector<int>;
using vvi = vector<vi>;
using pii = pair<int, int>;

ll n;

bool read() {
    if (!(cin >> n)) {
        return 0;
    }
    return 1;
}

set<ll> min_divs;

void test_div(ll min_d, bool print) {
    if (!print && min_divs.find(min_d) != min_divs.end()) {
        return;
    }

    vector<ll> divs;
    ll T = n;
    while (T % min_d == 0) {
        divs.pb(min_d);
        T /= min_d;
    }
    min_d++;
    while (T % min_d == 0) {
        divs.pb(min_d);
        T /= min_d;
    }

    if (T == 1) { // ok!
        if (!print) {
            min_divs.insert(min_d - 1);
        } else {
            printf("%d", sz(divs));
            for (auto d: divs) {
                printf(" %lld", d);
            }
            cout << '\n';
        }
    }
}

void solve() {
    // check 2^k
    ll T = n;
    while (T != 1 && T % 2 == 0) {
        T /= 2;
    }
    if (T == 1) {
        cout << -1 << '\n';
        return;
    }

    min_divs.clear();

    // 1
    min_divs.insert(n);

    // 2
    ll sqn = sqrt((long double)n);

    for (ll d = max(2ll, sqn - 10); d <= min(n - 1, sqn + 10); d++) {
        if (n % d == 0) {
            test_div(d, 0);
        }
    }

    // 3
    const ll LIM = 2 * (int)1e6;
    for (int i = 2; i <= min(LIM, n); i++) {
        if (n % i == 0) {
            //cerr << "test " << i << endl;
            test_div(i, 0);
        }
    }

    cout << sz(min_divs) << '\n';
    for (auto d: min_divs) {
        //cerr << "here: " << d << endl;
        test_div(d, 1);
    }
}


int main() {
#ifdef LOCAL
    freopen(FILE_NAME ".in", "r", stdin);
//    freopen(FILE_NAME ".out", "w", stdout);
#else
    freopen(FILE_NAME ".in", "r", stdin);
    freopen(FILE_NAME ".out", "w", stdout);
#endif

    while (read()) {
        solve();
    }

    return 0;
}





