#include <fstream>
#include <iostream>
#include <vector>

using ll = long long;

ll bsr(ll x) {
	ll shift = 31;
	while (!(x & (1 << shift))) { shift--; }
	return shift;
}
bool is_2_pow(ll x) { return (x & (x - 1)) == 0; }
ll max(ll a, ll b, ll c, ll d) { return a < b ? c : d; }

double P = 0, N = 0;

struct node { 
	ll endPref, sumPos, sumNeg, sumPosAll, sumNegAll;
	void set(ll a, ll ind) {
		if (a > 0) {
			endPref = ind + 1;
			sumPosAll = a;
			sumPos = a;
			sumNeg = 0;
			sumNegAll = 0;
		} else {
			sumNegAll = a;
			sumNeg = a;
			sumPos = 0;
			sumPosAll = 0;
			endPref = ind;
		}
	}
	double sum() { return (double)sumPosAll / P - (double)sumNegAll / N; }
	double sum1() {return (double)sumPos / P - (double)sumNeg / N; }
	double sum2(node& n) { return sum() + n.sum1(); }
};
std::ostream& operator<<(std::ostream& c, node& n) {
	c << '(' << n.endPref << ' ' << n.sumPos << ' ' << n.sumPosAll << ' ' <<
		n.sumNeg << ' ' << n.sumNegAll << ')';
	return c;
}
node operator+(node& a, node& b) {
	bool trig = a.sum1() >= a.sum2(b);
	return node{
		trig ? a.endPref : b.endPref,
		trig ? a.sumPos : a.sumPosAll + b.sumPos,
		trig ? a.sumNeg : a.sumNegAll + b.sumNeg,
		a.sumPosAll + b.sumPosAll,
		a.sumNegAll + b.sumNegAll
	};
}
class Tree {
	ll mlevel;
	std::vector<node> vec;
public:
	Tree(std::vector<ll>& _):vec(_.size() << 2) {
		ll s = _.size();
		mlevel = is_2_pow(s) ? bsr(s) : bsr(s) + 1;
		ll level = mlevel;
		for (ll i = 0; i < s; i++) {
			vec[(1 << level) + i - 1].set(_[i], i);
		}
		for (ll i = s; i < (1 << level); i++) {
			vec[(1 << level) + i - 1] = { s, 0, 0, 0, 0 };
		}
		level--;
		for (; level >= 0; level--) {
			for (ll i = 0; i < (1 << level); i++) {
				vec[(1 << level) + i - 1] = vec[(1 << (level+1)) + (i << 1) - 1] + vec[(1 << (level+1)) + (i << 1)];
			}
		}
	}
	void update(ll ind, ll value) {
		if (vec[(1 << mlevel) + ind - 1].sum() > 0) {
			P -= vec[(1 << mlevel) + ind - 1].sumPosAll;
		} else {
			N -= vec[(1 << mlevel) + ind - 1].sumNegAll;
		}
		if (value > 0) {
			P += value;
		} else {
			N += value;
		}
		vec[(1 << mlevel) + ind - 1].set(value, ind);
		
		ind = (1 << mlevel) + ind - 1;
		for (ll level = mlevel - 1; level >= 0; level--, ind = (ind - 1) >> 1) {
			vec[(ind - 1) >> 1] = (ind & 1) ? (vec[ind] + vec[ind + 1]) : (vec[ind - 1] + vec[ind]);
		}
	}
	ll get() { return vec[0].endPref; }
	void prll() { for (auto i : vec) { std::cout << i << ' '; } std::cout << '\n'; }
};

FILE *iF, *oF;

ll getll() { ll temp; fscanf_s(iF, "%d", &temp); return temp; }

ll main() {
	fopen_s(&iF, "joker.in", "r");
	fopen_s(&oF, "joker.out", "w");
	ll n = getll(), m = getll();
	std::vector<ll> in; in.reserve(n);
	for (ll i = 0; i < n; i++) {
		ll temp = getll();
		if (temp < 0) { N += temp; }
		else { P += temp; }
		in.push_back(temp);
	}
	Tree tree(in);
	tree.prll(); system("pause");
	fprintf_s(oF, "%d\n", tree.get());
	for (ll i = 0; i < m; i++) {
		ll a = getll()-1, b = getll();
		tree.update(a, b);
		fprintf_s(oF, "%d\n", tree.get());
	}
	return 0;
}