#include <stdio.h>
#include <inttypes.h>
#include <vector>
#include <math.h>

uint64_t mpow(uint64_t k, int p) {
    if (p == 0)
        return 1;
    while (p > 1)
    {
        k *= k;
        p--;
    }
    return k;
}

struct answer
{
    uint64_t k1, k2, k3;
    int a1, a2, a3;
};

int main() {
    FILE* input = fopen("little.in", "r");
    FILE* output = fopen("little.out", "w");

    uint64_t n = 0;
    fscanf(input, "%llu", &n);

    std::vector<answer> res;

    int d = 1;
    int fin = 0;
    bool infin = false;
    while (fin < 3) {
        uint64_t k = pow((double) n, 1.0 / d);

        uint64_t mindk = k;
        uint64_t ck = k + 1;
        while (true)
        {
            uint64_t pr = mpow(ck, d);
            if (pr > n)
                break;

            mindk = ck;
            ck++;
        }

        k = mindk;
        if (k <= 2)
            fin++;

        uint64_t k1 = k - 1;
        uint64_t k2 = k;
        uint64_t k3 = k + 1;

        for (int a1 = 0; a1 <= d; a1++)
        {
            for (int a2 = 0; a2 <= d - a1; a2++)
            {
                int a3 = d - a1 - a2;
                if (a3 < 0) continue;

                uint64_t pred = mpow(k1, a1) * mpow(k2, a2) * mpow(k3, a3);
                if (pred == n)
                {
                    if ((k1 == 1 && a1 > 0) || (k2 == 1 && a2 > 0)) {
                        infin = true;
                        fin = 10;
                    }

                    answer ans;
                    ans.k1 = k1;
                    ans.k2 = k2;
                    ans.k3 = k3;
                    ans.a1 = a1;
                    ans.a2 = a2;
                    ans.a3 = a3;
                    res.push_back(ans);
                }
            }
        }

        d++;
    }

    if (!infin)
    {
        fprintf(output, "%llu\n", (uint64_t) res.size());
        for (uint64_t i = 0; i < res.size(); i++)
        {
            answer &a = res[i];
            fprintf(output, "%d ", a.a1 + a.a2 + a.a3);
            for (int j = 0; j < a.a1; j++)
                fprintf(output, "%llu ", a.k1);
            for (int j = 0; j < a.a2; j++)
                fprintf(output, "%llu ", a.k2);
            for (int j = 0; j < a.a3; j++)
                fprintf(output, "%llu ", a.k3);
            fprintf(output, "\n");
        }
    }
    else
        fprintf(output, "%d", -1);

    fclose(input);
    fclose(output);
    return 0;
}