#include <stdio.h>
#include <inttypes.h>
#include <vector>
#include <math.h>

uint64_t mpow(uint64_t k, int p) {
    if (p == 0)
        return 1;
    uint64_t res = k;
    while (p > 1)
    {
        res *= k;
        p--;
    }
    return res;
}

struct answer
{
    uint64_t k1, k2, k3;
    int a1, a2, a3;
};

void checkK(std::vector<answer> &res, uint64_t k, uint64_t n, int d, int &fin, bool &infin)
{
    uint64_t k1 = k - 1;
    uint64_t k2 = k;
    uint64_t k3 = k + 1;

    for (int a1 = 0; a1 <= d; a1++) {
        for (int a2 = 0; a2 <= d - a1; a2++) {
            int a3 = d - a1 - a2;
            if (a3 < 0) continue;

            uint64_t pred = mpow(k1, a1) * mpow(k2, a2) * mpow(k3, a3);
            if (pred == n) {
                if ((k1 == 1 && a1 > 0) || (k2 == 1 && a2 > 0)) {
                    infin = true;
                    fin = 10;
                }

                answer ans;
                ans.k1 = k1;
                ans.k2 = k2;
                ans.k3 = k3;
                ans.a1 = a1;
                ans.a2 = a2;
                ans.a3 = a3;
                res.push_back(ans);
            }
        }
    }
}

bool equal(answer &a1, answer &a2)
{
    bool a = a1.a2 == a2.a1 && a1.a3 == a2.a2 &&
             a1.k2 == a2.k1 && a1.k3 == a2.k2 && a1.a1 == 0 && a2.a3 == 0;
    bool b = a1.a1 == a2.a1 && a1.a2 == a2.a2 && a1.a3 == a2.a3 &&
             a1.k1 == a2.k1 && a1.k2 == a2.k2 && a1.k3 == a2.k3;
    return a || b;
}

void distinct(std::vector<answer> &res1, std::vector<answer> &res2)
{
    std::vector<answer> fres;
    for (int i = 0; i < res2.size(); i++) {
        bool nw = true;
        for (int j = 0; j < fres.size(); j++) {
            if (equal(fres[j], res2[i])) {
                nw = false;
                break;
            }
        }
        if (nw) {
            fres.push_back(res2[i]);
        }
    }
    for (int i = 0; i < res1.size(); i++) {
        bool nw = true;
        for (int j = 0; j < fres.size(); j++) {
            if (equal(fres[j], res1[i])) {
                nw = false;
                break;
            }
        }
        if (nw) {
            fres.push_back(res1[i]);
        }
    }
    res2.clear();
    res1 = fres;
}

int main() {
    FILE* input = fopen("little.in", "r");
    FILE* output = fopen("little.out", "w");

    uint64_t n = 0;
    fscanf(input, "%llu", &n);

    std::vector<answer> res;

    int d = 1;
    int fin = 0;
    bool infin = false;
    while (fin < 3) {
        uint64_t k = pow((double) n, 1.0 / d);

        uint64_t mindk = k;
        uint64_t ck = k + 1;
        while (true)
        {
            uint64_t pr = mpow(ck, d);
            if (pr > n)
                break;

            mindk = ck;
            ck++;
        }

        k = mindk;
        if (k <= 2)
            fin++;

        std::vector<answer> res1;
        std::vector<answer> res2;
        checkK(res1, k, n, d, fin, infin);
        checkK(res2, k + 1, n, d, fin, infin);
        distinct(res1, res2);

        for (int h = 0; h < res1.size(); h++)
            res.push_back(res1[h]);

        d++;
    }

    if (!infin)
    {
        fprintf(output, "%llu\n", (uint64_t) res.size());
        for (uint64_t i = 0; i < res.size(); i++)
        {
            answer &a = res[i];
            fprintf(output, "%d ", a.a1 + a.a2 + a.a3);
            for (int j = 0; j < a.a1; j++)
                fprintf(output, "%llu ", a.k1);
            for (int j = 0; j < a.a2; j++)
                fprintf(output, "%llu ", a.k2);
            for (int j = 0; j < a.a3; j++)
                fprintf(output, "%llu ", a.k3);
            fprintf(output, "\n");
        }
    }
    else
        fprintf(output, "%d", -1);

    fclose(input);
    fclose(output);
    return 0;
}